import { AfterViewInit, ElementRef, EventEmitter, OnChanges, OnDestroy, QueryList, Renderer2, SimpleChanges, TemplateRef } from '@angular/core';
import { AlertCarouselItemComponent } from './alert-carousel-item.component';
import { AlertType } from './alert.types';
import * as i0 from "@angular/core";
export declare class AlertComponent implements OnChanges, OnDestroy, AfterViewInit {
    private el;
    private renderer;
    type: AlertType;
    cssClass: string;
    closeable: boolean;
    showIcon: boolean;
    autoplay: boolean;
    autoplaySpeed: number;
    transitionSpeed: number;
    operationTemplate: TemplateRef<any>;
    set dismissTime(time: number);
    closeEvent: EventEmitter<AlertComponent>;
    box: ElementRef<any>;
    carouselItems: QueryList<AlertCarouselItemComponent>;
    hide: boolean;
    autoplayHeight: string;
    carouselNum: number;
    currentIndex: number;
    scheduledId: any;
    SINGLE_LINE_HEIGHT: string;
    constructor(el: ElementRef, renderer: Renderer2);
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    renderCarouselItem(): void;
    next: () => void;
    autoScheduleTransition(): void;
    clearScheduledTransition(): void;
    translatePosition(size: number): void;
    close: () => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AlertComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AlertComponent, "d-alert", never, { "type": { "alias": "type"; "required": false; }; "cssClass": { "alias": "cssClass"; "required": false; }; "closeable": { "alias": "closeable"; "required": false; }; "showIcon": { "alias": "showIcon"; "required": false; }; "autoplay": { "alias": "autoplay"; "required": false; }; "autoplaySpeed": { "alias": "autoplaySpeed"; "required": false; }; "transitionSpeed": { "alias": "transitionSpeed"; "required": false; }; "operationTemplate": { "alias": "operationTemplate"; "required": false; }; "dismissTime": { "alias": "dismissTime"; "required": false; }; }, { "closeEvent": "closeEvent"; }, ["carouselItems"], ["*"], false, never>;
}
