import { AfterContentChecked, ChangeDetectorRef, ElementRef, EventEmitter, TemplateRef } from '@angular/core';
import * as i0 from "@angular/core";
export type IButtonType = 'button' | 'submit' | 'reset';
/**
 * 类型中text-dark参数废弃
 */
export type IButtonStyle = 'common' | 'primary' | 'text' | 'text-dark' | 'danger' | 'success' | 'warning';
export type IButtonPosition = 'left' | 'right' | 'default';
export type IButtonSize = 'lg' | 'md' | 'sm' | 'xs';
export declare class ButtonComponent implements AfterContentChecked {
    private cd;
    id: string;
    type: IButtonType;
    bsStyle: IButtonStyle;
    shape: 'circle';
    bsSize: IButtonSize;
    /**
     * @deprecated
     * 原左右按钮用按钮组实现
     */
    bsPosition: IButtonPosition;
    bordered: boolean;
    icon: string;
    disabled: boolean;
    showLoading: boolean;
    width?: string;
    autofocus: boolean;
    loadingTemplateRef: TemplateRef<any>;
    btnClick: EventEmitter<MouseEvent>;
    buttonContent: ElementRef;
    handleDisabled($event: Event): void;
    waveLeft: number;
    waveTop: number;
    showWave: boolean;
    isMouseDown: boolean;
    constructor(cd: ChangeDetectorRef);
    onClick(event: any): void;
    showClickWave(event: any): void;
    ngAfterContentChecked(): void;
    hasContent(): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<ButtonComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ButtonComponent, "d-button", never, { "id": { "alias": "id"; "required": false; }; "type": { "alias": "type"; "required": false; }; "bsStyle": { "alias": "bsStyle"; "required": false; }; "shape": { "alias": "shape"; "required": false; }; "bsSize": { "alias": "bsSize"; "required": false; }; "bsPosition": { "alias": "bsPosition"; "required": false; }; "bordered": { "alias": "bordered"; "required": false; }; "icon": { "alias": "icon"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "showLoading": { "alias": "showLoading"; "required": false; }; "width": { "alias": "width"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "loadingTemplateRef": { "alias": "loadingTemplateRef"; "required": false; }; }, { "btnClick": "btnClick"; }, never, ["*"], false, never>;
}
