import { AfterContentInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, QueryList, Renderer2, SimpleChanges } from '@angular/core';
import { CarouselItemComponent } from './carousel-item.component';
import * as i0 from "@angular/core";
export type ArrowTrigger = 'hover' | 'never' | 'always';
export type DotTrigger = 'click' | 'hover';
export type DotPosition = 'bottom' | 'top';
export declare class CarouselComponent implements OnInit, AfterContentInit, OnChanges, OnDestroy {
    private el;
    private renderer;
    private cdr;
    arrowTrigger: ArrowTrigger;
    autoplay: boolean;
    autoplaySpeed: number;
    transitionSpeed: number;
    height: string;
    showDots: boolean;
    dotPosition: DotPosition;
    dotTrigger: DotTrigger;
    activeIndex: number;
    activeIndexChange: EventEmitter<number>;
    items: QueryList<CarouselItemComponent>;
    showArrow: boolean;
    private itemContainer;
    private itemCount;
    private scheduledId;
    private currentIndex;
    constructor(el: ElementRef, renderer: Renderer2, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    arrowMouseEvent(type: any): void;
    prev(): void;
    next(): void;
    goTo(index: any): void;
    switchStep(index: any, type: any): void;
    private adjustTransition;
    private adjustPosition;
    private translatePosition;
    private initCarouselWidth;
    private autoScheduleTransition;
    private clearScheduledTransition;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CarouselComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CarouselComponent, "d-carousel", ["dCarousel"], { "arrowTrigger": { "alias": "arrowTrigger"; "required": false; }; "autoplay": { "alias": "autoplay"; "required": false; }; "autoplaySpeed": { "alias": "autoplaySpeed"; "required": false; }; "transitionSpeed": { "alias": "transitionSpeed"; "required": false; }; "height": { "alias": "height"; "required": false; }; "showDots": { "alias": "showDots"; "required": false; }; "dotPosition": { "alias": "dotPosition"; "required": false; }; "dotTrigger": { "alias": "dotTrigger"; "required": false; }; "activeIndex": { "alias": "activeIndex"; "required": false; }; }, { "activeIndexChange": "activeIndexChange"; }, ["items"], ["d-carousel-item"], false, never>;
}
