import { ChangeDetectorRef, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { Subject } from 'rxjs';
import { CascaderService } from './cascader.service';
import { CascaderItem } from './cascader.type';
import * as i0 from "@angular/core";
export declare class CascaderLiComponent implements OnInit, OnDestroy {
    private cascaderSrv;
    private cdr;
    width: number;
    trigger: 'click' | 'hover';
    option: CascaderItem;
    multiple: boolean;
    canSelectParent: boolean;
    colIndex: number;
    dropDownItemTemplate: TemplateRef<any>;
    isLazyLoad: boolean;
    checkboxRelation: {
        upward: boolean;
        downward: boolean;
    };
    dropdownEl: Element;
    isLeaf: boolean;
    selected: boolean;
    halfCheck: boolean;
    active: boolean;
    unsubscribe$: Subject<void>;
    onClick(event: Event): void;
    onMouseEnter(event: any): void;
    constructor(cascaderSrv: CascaderService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    initObserable(): void;
    clickLeaf(): void;
    clickItem(): void;
    clickCheckbox(event: Event): void;
    avoidCheckboxChange(): boolean;
    updateValue(checked: boolean): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CascaderLiComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CascaderLiComponent, "d-cascader-li", never, { "width": { "alias": "width"; "required": false; }; "trigger": { "alias": "trigger"; "required": false; }; "option": { "alias": "option"; "required": false; }; "multiple": { "alias": "multiple"; "required": false; }; "canSelectParent": { "alias": "canSelectParent"; "required": false; }; "colIndex": { "alias": "colIndex"; "required": false; }; "dropDownItemTemplate": { "alias": "dropDownItemTemplate"; "required": false; }; "isLazyLoad": { "alias": "isLazyLoad"; "required": false; }; "checkboxRelation": { "alias": "checkboxRelation"; "required": false; }; }, {}, never, never, false, never>;
}
