import { ElementRef, EventEmitter, OnChanges, SimpleChanges, AfterViewInit, OnDestroy } from '@angular/core';
import { GridStackNode, GridStackWidget } from 'gridstack';
import { GridStackNodeCompatible } from '../grid-stack.config';
import { GridStackService } from '../grid-stack.service';
import * as i0 from "@angular/core";
export type DashboardWidget = GridStackWidget & {
    widgetData?: any;
    [prop: string]: any;
};
export declare class DashboardWidgetComponent implements GridStackNode, OnChanges, AfterViewInit, OnDestroy {
    elem: ElementRef;
    private gridStackService;
    static autoNumberedId: number;
    x: number;
    xChange: EventEmitter<number>;
    y: number;
    yChange: EventEmitter<number>;
    width: number;
    widthChange: EventEmitter<number>;
    height: number;
    heightChange: EventEmitter<number>;
    id: string;
    maxWidth: number;
    maxHeight: number;
    minWidth: number;
    minHeight: number;
    noResize: boolean;
    noMove: boolean;
    autoPosition: boolean;
    locked: boolean;
    widgetData: any;
    widgetInit: EventEmitter<any>;
    widgetResize: EventEmitter<{
        width: number;
        height: number;
    }>;
    widgetDestroy: EventEmitter<any>;
    hostBinding: boolean;
    generatedId: string;
    constructor(elem: ElementRef, gridStackService: GridStackService);
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    handleChange({ x, y, width, height }: GridStackNodeCompatible): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DashboardWidgetComponent, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DashboardWidgetComponent, "d-dashboard-widget", ["dDashboardWidget"], { "x": { "alias": "x"; "required": false; }; "y": { "alias": "y"; "required": false; }; "width": { "alias": "width"; "required": false; }; "height": { "alias": "height"; "required": false; }; "id": { "alias": "id"; "required": false; }; "maxWidth": { "alias": "maxWidth"; "required": false; }; "maxHeight": { "alias": "maxHeight"; "required": false; }; "minWidth": { "alias": "minWidth"; "required": false; }; "minHeight": { "alias": "minHeight"; "required": false; }; "noResize": { "alias": "noResize"; "required": false; }; "noMove": { "alias": "noMove"; "required": false; }; "autoPosition": { "alias": "autoPosition"; "required": false; }; "locked": { "alias": "locked"; "required": false; }; "widgetData": { "alias": "widgetData"; "required": false; }; }, { "xChange": "xChange"; "yChange": "yChange"; "widthChange": "widthChange"; "heightChange": "heightChange"; "widgetInit": "widgetInit"; "widgetResize": "widgetResize"; "widgetDestroy": "widgetDestroy"; }, never, ["*"], false, never>;
}
