import { ChangeDetectorRef, ComponentFactoryResolver, ElementRef, NgZone, OnChanges, OnDestroy, OnInit, SimpleChange } from '@angular/core';
import { Subscription } from 'rxjs';
import { EditorDirective } from './editor-host.directive';
import { DataTableColumnTmplComponent } from './tmpl/data-table-column-tmpl.component';
import * as i0 from "@angular/core";
export declare class DataTableCellComponent implements OnInit, OnChanges, OnDestroy {
    dt: any;
    private changeDetectorRef;
    private componentFactoryResolver;
    rowComponent: any;
    private cellRef;
    private ngZone;
    editorHost: EditorDirective;
    rowIndex: number;
    colIndex: number;
    column: DataTableColumnTmplComponent;
    rowItem: any;
    editModel: string;
    isEditRow: boolean;
    timeout: number;
    tableLevel: number;
    get isEditable(): boolean;
    isCellEdit: boolean;
    forceUpdateSubscription: Subscription;
    documentClickSubscription: Subscription;
    tdMousedownSubscription: Subscription;
    tdMouseupSubscription: Subscription;
    clickInTd: boolean;
    cellEditorClickSubscription: Subscription;
    cellActionSubscription: Subscription;
    clickCount: number;
    timeoutId: any;
    fieldEditDenied: boolean;
    templateEditorActive: boolean;
    dynamicEditorActive: boolean;
    constructor(dt: any, changeDetectorRef: ChangeDetectorRef, componentFactoryResolver: ComponentFactoryResolver, rowComponent: any, cellRef: ElementRef, ngZone: NgZone);
    ngOnInit(): void;
    ngOnChanges(changes: {
        [propKey: string]: SimpleChange;
    }): void;
    updateEditable(rowItem: any): void;
    onCellClick($event: any): void;
    onCellDBClick($event: any): void;
    forceUpdate(): void;
    finishCellEdit($event?: Event): void;
    isCellEditEnable(column: any, rowItem: any): boolean;
    ngOnDestroy(): void;
    private unSubscription;
    creatCellEditor(): void;
    cellEditing($event: any): void;
    toggleChildTable(rowItem: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DataTableCellComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DataTableCellComponent, "d-data-table-cell,[dDataTableCell]", never, { "rowIndex": { "alias": "rowIndex"; "required": false; }; "colIndex": { "alias": "colIndex"; "required": false; }; "column": { "alias": "column"; "required": false; }; "rowItem": { "alias": "rowItem"; "required": false; }; "editModel": { "alias": "editModel"; "required": false; }; "isEditRow": { "alias": "isEditRow"; "required": false; }; "timeout": { "alias": "timeout"; "required": false; }; "tableLevel": { "alias": "tableLevel"; "required": false; }; }, {}, never, never, false, never>;
}
