import { __decorate, __metadata } from 'tslib';
import * as i3 from '@angular/common';
import { DOCUMENT, CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Directive, Input, EventEmitter, Component, Inject, HostBinding, Output, ViewChild, ViewChildren, ContentChildren, NgModule } from '@angular/core';
import * as i2 from 'ng-devui/i18n';
import * as i13 from 'ng-devui/tree';
import { TreeModule } from 'ng-devui/tree';
import { DefaultIcons } from 'ng-devui/tree-select';
import * as i1 from 'ng-devui/utils';
import { DefaultDateConverter, WithConfig, PopperModule } from 'ng-devui/utils';
import { intersectionBy, merge, cloneDeep, mergeWith, isEqual } from 'lodash-es';
import { Subject, fromEvent } from 'rxjs';
import { takeUntil, tap, debounceTime } from 'rxjs/operators';
import * as i4 from 'ng-devui/form';
import { FormModule } from 'ng-devui/form';
import * as i5 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i6 from 'ng-devui/dropdown';
import { DropDownModule } from 'ng-devui/dropdown';
import * as i7 from 'ng-devui/text-input';
import { TextInputModule } from 'ng-devui/text-input';
import * as i8 from 'ng-devui/search';
import { SearchModule } from 'ng-devui/search';
import * as i9 from 'ng-devui/tags';
import { TagsModule } from 'ng-devui/tags';
import * as i10 from 'ng-devui/button';
import { ButtonModule } from 'ng-devui/button';
import * as i11 from 'ng-devui/checkbox';
import { CheckBoxModule } from 'ng-devui/checkbox';
import * as i12 from 'ng-devui/input-number';
import { InputNumberModule } from 'ng-devui/input-number';
import * as i14 from 'ng-devui/datepicker-pro';
import { DatepickerProModule } from 'ng-devui/datepicker-pro';
import { LoadingModule } from 'ng-devui/loading';

const COLORS = [
    '#f2f5fc',
    '#e9edfa',
    '#beccfa',
    '#96adfa',
    '#7693f5',
    '#5e7ce0',
    '#526ecc',
    '#465eb8',
    '#3c51a6',
    '#344899',
    '#2a3c85',
    '#ebf6ff',
    '#d1ebff',
    '#b8e0ff',
    '#9ed5ff',
    '#85caff',
    '#6cbfff',
    '#4ea6e6',
    '#3590cc',
    '#207ab3',
    '#0f6999',
    '#035880',
    '#edfff9',
    '#cffcee',
    '#acf2dc',
    '#8be8cb',
    '#6ddebb',
    '#50d4ab',
    '#3ac295',
    '#27b080',
    '#169e6c',
    '#088c58',
    '#007a45',
    '#f0ffe6',
    '#e5ffd4',
    '#d8fcc0',
    '#c5f2a7',
    '#b3e890',
    '#a6dd82',
    '#92cc68',
    '#7eba50',
    '#6ca83b',
    '#5e9629',
    '#518519',
    '#fffbf0',
    '#fff1c2',
    '#ffe794',
    '#ffdc66',
    '#ffd138',
    '#fac20a',
    '#e3aa00',
    '#cc9600',
    '#b58200',
    '#9e6f00',
    '#875c00',
    '#fff3e8',
    '#ffe1c7',
    '#ffd0a6',
    '#ffbf85',
    '#ffad63',
    '#fa9841',
    '#e37d29',
    '#cc6414',
    '#b54e04',
    '#9e3f00',
    '#873400',
    '#ffeeed',
    '#ffd5d4',
    '#ffbcba',
    '#ffa4a1',
    '#ff8b87',
    '#f66f6a',
    '#de504e',
    '#c73636',
    '#b02121',
    '#991111',
    '#820404',
    '#ffedf3',
    '#ffd4e3',
    '#ffbad2',
    '#ffa1c2',
    '#fc86b0',
    '#f3689a',
    '#db4d83',
    '#c4356e',
    '#ad215b',
    '#96114d',
    '#800440',
    '#f5f0ff',
    '#e7d9ff',
    '#d8c2ff',
    '#caabff',
    '#bc94ff',
    '#a97af8',
    '#8a5ce0',
    '#6f42c9',
    '#572db3',
    '#3f1a9c',
    '#2a0c85',
];

class ContentTemplateDirective {
    constructor(template) {
        this.template = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ContentTemplateDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "17.2.3", type: ContentTemplateDirective, selector: "ng-template[field], ng-template[dField]", inputs: { field: "field", dField: "dField" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ContentTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    /* eslint-disable */
                    selector: 'ng-template[field], ng-template[dField]',
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }], propDecorators: { field: [{
                type: Input
            }], dField: [{
                type: Input
            }] } });

class DefaultTemplateDirective {
    constructor(template) {
        this.template = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: DefaultTemplateDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "17.2.3", type: DefaultTemplateDirective, selector: "ng-template[type], ng-template[dType]", inputs: { type: "type", dType: "dType" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: DefaultTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    /* eslint-disable */
                    selector: 'ng-template[type], ng-template[dType]',
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }], propDecorators: { type: [{
                type: Input
            }], dType: [{
                type: Input
            }] } });

class CategorySearchComponent {
    static { this.ID_SEED = 0; }
    get hasGlowStyle() {
        return this.showGlowStyle;
    }
    get showFilterNameClear() {
        return typeof this.filterName === 'string' && this.filterName.length > 0;
    }
    get showExtendedConfig() {
        return this.operationConfig.show ?? Boolean(this.selectedTags.length || this.searchKey);
    }
    constructor(devConfigService, doc, i18n) {
        this.devConfigService = devConfigService;
        this.doc = doc;
        this.i18n = i18n;
        this.category = [];
        this.defaultSearchField = [];
        this.selectedTags = [];
        /**
         * @deprecated
         */
        this.allowClear = true;
        /**
         * @deprecated
         */
        this.allowSave = true;
        /**
         * @deprecated
         */
        this.allowShowMore = false;
        this.toggleScrollToTail = false;
        this.searchKey = '';
        this.inputReadOnly = false;
        this.showSearchCategory = true; // 配置是否显示搜索相关下拉选项
        this.categoryInGroup = false; // 是否按组别显示分类下拉列表
        this.textConfig = {
            keywordName: '',
            createFilter: '',
            filterTitle: '',
            labelConnector: '|',
            noCategoriesAvailable: '',
        };
        this.filterNameRules = [];
        this.styleType = 'default';
        this.showGlowStyle = true;
        this.searchEvent = new EventEmitter();
        this.selectedTagsChange = new EventEmitter();
        this.createFilterEvent = new EventEmitter();
        this.clearAllEvent = new EventEmitter();
        this.searchKeyChange = new EventEmitter();
        this.treeSearchKey = '';
        this.filterName = '';
        this.searchKeyCache = '';
        this.enterSearch = false;
        this.isShowSavePanel = false;
        this.isSearchCategory = false;
        this.isHover = false;
        this.isFocus = false;
        this.treeNoRecord = false;
        this.showNoDataTips = false;
        this.icons = DefaultIcons;
        this.destroy$ = new Subject();
        this.scrollToTailFlag = true; // 是否在更新标签内容后滚动至输入框的开关
        this.DROPDOWN_ANIMATION_TIMEOUT = 200; // 下拉动画延迟
        this.DELAY = 300; // 防抖延迟
        this.templates = {}; // 所有类型默认模板
        this.customTemplates = {}; // 按field标记的自定义模板集合
        this.joinLabelTypes = ['checkbox', 'label'];
        this.valueIsArrayTypes = ['dateRange', 'numberRange', 'treeSelect'];
        this.operationConfig = {
            clear: { show: true },
            save: { show: true },
            more: { show: false },
        };
        this.categoryOrder = [];
        this.categoryDictionary = {};
        this.document = this.doc;
        this.dateConverter = new DefaultDateConverter();
        this.id = CategorySearchComponent.ID_SEED++;
        this.showSearchConfig = { keyword: true, field: true, category: true, noCategoriesAvailableTip: true };
        this.i18n
            .langChange()
            .pipe(takeUntil(this.destroy$))
            .subscribe((data) => this.setI18nAndFilterText(data));
    }
    ngOnChanges(changes) {
        const { allowClear, allowSave, allowShowMore, defaultSearchField, category, extendedConfig, selectedTags, searchKey, showSearchCategory, textConfig, } = changes;
        const hasExtendChanged = [allowClear, allowSave, allowShowMore, extendedConfig].some((change) => change);
        if (searchKey) {
            // searchKey输入变化更新缓存，优先处理searchKey避免初始化时再添加关键字
            this.searchKeyCache = this.searchKey;
            this.setSearchKeyTag(false);
        }
        if (selectedTags?.previousValue?.length) {
            const result = intersectionBy([selectedTags.previousValue], selectedTags.currentValue, 'field');
            result.forEach((selectedTag) => {
                const item = this.category.find((categoryItem) => categoryItem.field === selectedTag.field);
                if (item?.value.value) {
                    this.resetValue(item);
                }
            });
        }
        if (defaultSearchField || category || selectedTags) {
            this.init();
        }
        if (showSearchCategory) {
            this.setSearchShow();
        }
        if (textConfig) {
            this.setI18nAndFilterText(this.i18n.getI18nText());
        }
        if (hasExtendChanged) {
            this.setExtendedConfig();
        }
    }
    ngAfterViewInit() {
        // 获取所有默认模板，规避脏检查添加延时
        setTimeout(() => this.defaultTemplates.forEach((item) => {
            this.templates[item.type || item.dType] = item.template;
        }));
        if (this.scrollBarContainer && this.inputEle) {
            // 初始化如果有滚动条直接位移至输入框
            this.scrollToTail(true);
            // 监听滚动事件，在跳转至指定标签后触发其下拉列表
            fromEvent(this.scrollBarContainer.nativeElement, 'scroll')
                .pipe(takeUntil(this.destroy$), tap(() => {
                // 指定标签在可视范围则展开下拉，不在可视范围，即触发滚动后清除定时的展开下拉动作
                if (this.scrollTimeout) {
                    clearTimeout(this.scrollTimeout);
                    this.scrollTimeout = undefined;
                }
                // TODO: 无法区分手动和自动滚动，待处理滚动时关闭已打开的下拉
            }), 
            // 300毫秒内不再触发滚动事件则展开下拉列表
            debounceTime(this.DELAY))
                .subscribe((event) => this.openCurrentScrollTagMenu(event));
        }
    }
    ngAfterContentInit() {
        this.setCustomTemplate(this.contentTemplates);
        this.contentTemplates.changes.subscribe((data) => this.setCustomTemplate(data));
    }
    ngOnDestroy() {
        this.destroy$.next();
        this.destroy$.complete();
    }
    setCustomTemplate(data) {
        if (data?.length && this.category) {
            this.customTemplates = {};
            data.forEach((item) => {
                this.customTemplates[item.field || item.dField] = item.template;
            });
            this.category.forEach((tag) => {
                tag.customTemplate = this.customTemplates[tag.field];
            });
            this.selectedTags.forEach((tag) => {
                tag.customTemplate = this.customTemplates[tag.field];
            });
        }
    }
    setI18nAndFilterText(data) {
        this.i18nCommonText = data.common;
        this.i18nCategorySearchText = data.categorySearch;
        this.textConfig.createFilter = this.textConfig.createFilter || this.i18nCategorySearchText?.saveFilter;
        this.textConfig.filterTitle = this.textConfig.filterTitle || this.i18nCategorySearchText?.filterTitle;
        this.showSearchConfig.keywordDescription =
            this.showSearchCategory['keywordDescription'] || this.i18nCategorySearchText.getSearchMessage;
        this.showSearchConfig.fieldDescription = this.showSearchCategory['fieldDescription'] || this.i18nCategorySearchText.getFindingMessage;
        this.showSearchConfig.categoryDescription =
            this.showSearchCategory['categoryDescription'] || this.i18nCategorySearchText.selectFilterCondition;
        // 关键字分类内文本不能随语言对象变化，需重新赋值
        const keyword = this.selectedTags.find((item) => item.field === 'devuiCategorySearchKeyword');
        if (keyword) {
            keyword.label = this.textConfig.keywordName || this.i18nCategorySearchText['keyword'];
            keyword.title = `${keyword.label}:${keyword.value?.label}`;
        }
    }
    setSearchShow() {
        const customConfig = typeof this.showSearchCategory === 'boolean'
            ? {
                keyword: this.showSearchCategory,
                field: this.showSearchCategory,
                category: this.showSearchCategory,
                noCategoriesAvailableTip: this.showSearchCategory,
            }
            : this.showSearchCategory;
        this.showSearchConfig = { ...this.showSearchConfig, ...customConfig };
    }
    setSearchKeyTag(isSearch = true) {
        const result = this.searchKey || this.searchKeyCache;
        if (this.showSearchConfig.keyword) {
            const existingSearchKeyTag = this.selectedTags.find((tag) => tag.field === 'devuiCategorySearchKeyword');
            if (existingSearchKeyTag && !isSearch && this.searchKey === '') {
                this.removeTag(existingSearchKeyTag);
            }
            else if (this.searchKey && this.searchKey !== existingSearchKeyTag?.value.value) {
                this.createSearchKeyTag(isSearch);
            }
        }
        this.searchKey = '';
        if (isSearch) {
            setTimeout(() => {
                this.enterSearch = false;
            }, this.DELAY);
        }
        return result;
    }
    createSearchKeyTag(isSearch) {
        const label = this.textConfig.keywordName || this.i18nCategorySearchText['keyword'];
        const searchKeyTag = {
            options: [],
            field: 'devuiCategorySearchKeyword',
            label: label,
            type: 'keyword',
            title: `${label}:${this.searchKey}`,
            value: {
                label: this.searchKey,
                value: this.searchKey,
                cache: this.searchKey,
            },
        };
        this.updateSelectedTags(searchKeyTag, isSearch);
        this.searchKeyCache = this.searchKey;
        this.searchKey = '';
    }
    setExtendedConfig() {
        const oldConfig = {
            clear: { show: this.allowClear },
            save: { show: this.allowSave },
            more: { show: this.allowShowMore },
        };
        merge(oldConfig, this.extendedConfig);
        merge(this.operationConfig, oldConfig);
    }
    init() {
        this.setValue(this.category);
        this.setValue(this.selectedTags, true);
        this.initCategoryDisplay(true);
        if (this.defaultSearchField?.length && this.category?.length) {
            this.searchField = this.category.filter((item) => this.defaultSearchField.includes(item.field) && !this.valueIsArrayTypes.includes(item.type));
        }
        // 初始化时判断已选中分类中最后一项是否赋值，未赋值则识别为正在处理的分类，优先显示赋值下拉列表
        if (this.selectedTags.length) {
            const [lastItem] = this.selectedTags.slice(-1);
            const isNull = lastItem.value[lastItem.filterKey || 'label'] === undefined;
            this.currentSelectTag =
                isNull && (lastItem.value.value === undefined || (Array.isArray(lastItem.value.value) && lastItem.value.value.length === 0))
                    ? lastItem
                    : undefined;
        }
        if (this.searchKeyCache) {
            this.searchKey = this.searchKeyCache;
            this.setSearchKeyTag(false);
        }
    }
    // 初始化tag的value属性：{filterKey | label, value, data}
    initCategoryItem(item) {
        const preValue = this.valueIsArrayTypes.includes(item.type) ? { value: [] } : { value: undefined };
        preValue[item.filterKey || 'label'] = undefined;
        if (item.value) {
            for (const prop in preValue) {
                if (item.value[prop] === undefined) {
                    item.value[prop] = preValue[prop];
                }
            }
        }
        else {
            item.value = preValue;
        }
        item.value.cache = (item.value.value && typeof item.value.value === 'object' && cloneDeep(item.value.value)) || item.value.value;
        if (item.type === 'treeSelect' && item.options && item.options.length) {
            item.value.options = cloneDeep(item.options);
        }
        item.customTemplate = this.customTemplates[item.field || item.dField] || item.customTemplate;
        return item;
    }
    mergeCheck(objValue, srcValue, key) {
        if (key === 'options' && objValue !== srcValue) {
            return srcValue;
        }
    }
    setValue(data, isSelectedTags = false) {
        if (Array.isArray(data) && data.length) {
            data.forEach((item) => {
                if (!isSelectedTags || !this.category) {
                    item = this.initCategoryItem(item);
                    return;
                }
                let result = '';
                const originItem = this.category.find((categoryItem) => categoryItem.field === item.field);
                mergeWith(item, originItem, this.mergeCheck);
                if (item.value.value) {
                    if (item.type === 'treeSelect') {
                        this.getTreeValue(item, false);
                        return;
                    }
                    item.value.cache = cloneDeep(item.value.value);
                    result = this.joinLabelTypes.includes(item.type) ? this.getItemValue(item.value.value, item.filterKey || 'label') : '';
                }
                item.title = this.setTitle(item, item.type, result);
                if (item.type === 'label' && item.options[0] && !item.options[0].$label) {
                    this.mergeToLabel(item);
                }
            });
        }
    }
    setTitle(tag, type, result) {
        return this.joinLabelTypes.includes(type)
            ? `${tag.label}: ${result || ''}`
            : `${tag.label}: ${result || (tag.value && tag.value[tag.filterKey || 'label']) || ''}`;
    }
    initCategoryDisplay(isInit = false) {
        const selectedTagsField = this.selectedTags.map((item) => item.field);
        if (isInit) {
            this.category = this.category || [];
            this.categoryOrder = [];
            this.categoryDictionary = {};
            this.initGroupAndDictionary();
            this.initCategoryOrder();
        }
        this.categoryDisplay = this.categoryOrder.map((item) => {
            item.isSelected = selectedTagsField.includes(item.field);
            this.handleGroupLength(item, item.isSelected, isInit);
            return item;
        });
        this.showNoDataTips = this.showSearchConfig.noCategoriesAvailableTip ? this.categoryDisplay.every((item) => item.isSelected) : false;
    }
    initGroupAndDictionary() {
        this.category.forEach((item) => {
            if (this.categoryInGroup && item.group) {
                if (this.categoryDictionary[item.group]) {
                    this.categoryDictionary[item.group].groupLength++;
                }
                else {
                    this.categoryDictionary[item.group] = { groupName: item.group, groupLength: 1, children: [] };
                }
                this.categoryDictionary[item.group].children.push(item);
            }
            this.categoryDictionary[item.field] = item;
        });
    }
    initCategoryOrder() {
        const keys = this.groupOrderConfig || Object.keys(this.categoryDictionary);
        keys.forEach((key) => {
            const item = this.categoryDictionary[key];
            if (item) {
                if (this.categoryInGroup) {
                    if (item.groupName) {
                        this.categoryOrder.push(item, ...item.children);
                    }
                    else if (!item.group) {
                        this.categoryOrder.push(item);
                    }
                }
                else {
                    this.categoryOrder.push(item);
                }
            }
        });
    }
    handleGroupLength(tag, isSelected, isInit = false) {
        if (this.categoryInGroup && tag.group) {
            const group = this.categoryDictionary[tag.group];
            const len = group.groupLength;
            group.groupLength = isSelected ? len - 1 : isInit ? len : len + 1;
            group.isSelected = group.groupLength === 0;
        }
    }
    insertCategoryToGroup(groupName, groupObj, item, isInsert) {
        if (!groupName) {
            return;
        }
        groupObj[groupName] = groupObj[groupName] || [];
        if (isInsert) {
            groupObj[groupName].push(item);
        }
    }
    searchCategory(item, value) {
        if (this.valueIsArrayTypes.includes(item.type)) {
            return;
        }
        this.updateFieldValue(item, value || this.searchKey);
        this.updateSelectedTags(item);
        this.searchKey = '';
        this.enterSearch = false;
        this.finishChoose();
    }
    searchInputValue(event) {
        if (event) {
            event.preventDefault();
            event.stopPropagation();
        }
        // 当有分类正在选择时输入关键字不处理
        if (!this.currentSelectTag) {
            this.searchEvent.emit({
                selectedTags: this.getSelectedTagsExceptKeyword(),
                searchKey: this.setSearchKeyTag(),
            });
        }
        this.isFocus = true;
    }
    chooseCategory(item, inputDropdown) {
        // 点选分组名称不处理
        if (item.groupLength !== undefined) {
            return;
        }
        setTimeout(() => {
            this.currentSelectTag = item;
            if (this.currentSelectTag.type === 'label') {
                this.currentSelectTag = this.mergeToLabel(this.currentSelectTag);
            }
            this.currentSelectTag.title = this.setTitle(this.currentSelectTag, this.currentSelectTag.type, '');
            inputDropdown.isOpen = true;
        }, this.DROPDOWN_ANIMATION_TIMEOUT);
        this.updateSelectedTags(item, false);
    }
    getSelectedTagsExceptKeyword() {
        return this.showSearchConfig.keyword
            ? this.selectedTags.filter((item) => item.field !== 'devuiCategorySearchKeyword')
            : this.selectedTags;
    }
    updateSelectedTags(tag, valueChanged = true) {
        this.canChange(tag, 'add').then((val) => {
            if (!val) {
                return;
            }
            const index = this.selectedTags.map((item) => item.field).indexOf(tag.field);
            if (index > -1) {
                if (!tag.value.value) {
                    // 通过输入选择分类时避免空值覆盖已选值
                    merge(tag, this.selectedTags[index]);
                }
                this.selectedTags[index] = tag;
            }
            else {
                this.selectedTags.push(tag);
            }
            if (valueChanged) {
                // 只在新增标签时位移滚动条
                if (this.scrollToTailFlag) {
                    setTimeout(() => this.scrollToTail());
                }
                this.selectedTagsChange.emit({
                    selectedTags: this.getSelectedTagsExceptKeyword(),
                    currentChangeTag: tag,
                    operation: 'add',
                });
                this.isSearchCategory = false;
            }
            else {
                this.resolveCategoryDisplay(tag, 'delete');
            }
        });
    }
    // 判断滚动条是否存在，如果存在自动滚动到末尾的输入框
    scrollToTail(isInit) {
        const dom = this.scrollBarContainer.nativeElement;
        if (this.toggleScrollToTail && dom.scrollWidth > dom.clientWidth) {
            if (isInit) {
                dom.scrollLeft = dom.scrollWidth - dom.clientWidth;
            }
            else {
                this.inputEle.nativeElement.scrollIntoView({ behavior: 'smooth', block: 'nearest', inline: 'nearest' });
            }
        }
        else if (!isInit) {
            // 初始化不聚焦，避免展开下拉
            this.inputEle.nativeElement.focus();
        }
    }
    // 滚动至指定的tag
    scrollToTag(index, event) {
        const tags = this.scrollBarContainer?.nativeElement.querySelectorAll('ul.devui-category-search-line>li');
        if (tags[index]) {
            this.currentScrollTagIndex = index;
            tags[index].scrollIntoView({ behavior: 'smooth', block: 'nearest', inline: 'nearest' });
            this.scrollTimeout = setTimeout(() => this.openCurrentScrollTagMenu(event), this.DELAY);
        }
    }
    openCurrentScrollTagMenu(event) {
        if (this.currentScrollTagIndex !== undefined) {
            const dropdownArr = this.selectedDropdownList.toArray();
            this.openMenu(dropdownArr[this.currentScrollTagIndex], event);
            this.currentScrollTagIndex = undefined;
        }
    }
    updateFieldValue(field, value) {
        const result = {};
        const filterKey = field.filterKey || 'label';
        const colorKey = field.colorKey || 'color';
        result[filterKey] = value;
        if (field.type === 'radio') {
            field.value.value = { [filterKey]: value };
        }
        if (field.type === 'textInput') {
            field.value.value = value;
        }
        if (field.type === 'label') {
            if (field.options[0] && !field.options[0].$label) {
                this.mergeToLabel(field);
            }
            result[colorKey] = COLORS[Math.floor(COLORS.length * Math.random())];
            result['$label'] = `${value}_${result[colorKey]}`;
        }
        if (this.joinLabelTypes.includes(field.type)) {
            field.value.value = [result];
        }
        field.value[filterKey] = value;
        field.value.cache = cloneDeep(field.value.value);
        field.title = this.setTitle(field, field.type, value);
    }
    removeTag(tag, event) {
        this.canChange(tag, 'delete').then((val) => {
            if (!val) {
                if (this.beforeTagChange && event) {
                    event.stopPropagation();
                }
                return;
            }
            tag = this.resetValue(tag);
            this.selectedTags = this.selectedTags.filter((item) => item.field !== tag.field);
            const result = this.getSelectedTagsExceptKeyword();
            if (tag.type === 'keyword') {
                this.searchKey = this.searchKey === this.searchKeyCache ? '' : this.searchKey;
                this.searchKeyCache = '';
                this.enterSearch = this.searchKey !== '';
                this.searchEvent.emit({ selectedTags: result, searchKey: this.searchKey });
            }
            else {
                this.resolveCategoryDisplay(tag, 'add');
                this.selectedTagsChange.emit({ selectedTags: result, currentChangeTag: tag, operation: 'delete' });
            }
            this.currentSelectTag = undefined;
        });
    }
    checkInputSearching() {
        this.isFocus = true;
        if (this.searchKey === '') {
            this.enterSearch = false;
        }
        else {
            this.enterSearch = true;
        }
    }
    // 解决dropdownMenu展开时焦点会自动到toggle上的问题
    focusInput() {
        setTimeout(() => {
            this.inputEle.nativeElement.focus();
        });
    }
    // 失焦时关闭当前下拉列表，延时用以防止关闭掉点击分类展开的内容列表
    blurInput(event) {
        this.blurTimer = setTimeout(() => {
            const className = event.relatedTarget && event.relatedTarget['className'];
            const outsideHost = !className || (typeof className === 'string' && className.indexOf(`devui-category-dropdown-menu-${this.id}`) === -1);
            if (!this.currentSelectTag && this.currentOpenDropdown && outsideHost) {
                this.currentOpenDropdown.isOpen = false;
            }
        }, this.DELAY);
    }
    openMenu(inputDropdown, event) {
        const code = event['code'];
        if (inputDropdown.isOpen || (event.type === 'keyup' && ['Enter', 'Backspace', 'Escape'].includes(code))) {
            return;
        }
        setTimeout(() => {
            if (!inputDropdown.isOpen) {
                inputDropdown.toggle();
            }
        });
    }
    closeMenu(inputDropdown) {
        if (inputDropdown.isOpen) {
            inputDropdown.toggle();
        }
    }
    backspaceEvent(inputDropdown) {
        if (this.searchKey) {
            return;
        }
        if (this.currentSelectTag) {
            this.currentSelectTag = undefined;
            this.closeMenu(inputDropdown);
            return;
        }
        if (this.selectedTags.length) {
            const tag = this.selectedTags[this.selectedTags.length - 1];
            this.removeTag(tag);
        }
        this.closeMenu(inputDropdown);
    }
    canChange(tag, operation) {
        let changeResult = Promise.resolve(true);
        if (this.beforeTagChange) {
            const result = this.beforeTagChange(tag, this.searchKey, operation);
            if (typeof result !== 'undefined') {
                if (result.then) {
                    changeResult = result;
                }
                else if (result.subscribe) {
                    changeResult = result.toPromise();
                }
                else {
                    changeResult = Promise.resolve(result);
                }
            }
        }
        return changeResult;
    }
    finishChoose() {
        this.currentSelectTag = undefined;
        this.inputEle.nativeElement.focus();
    }
    clearFilter(event) {
        if (this.selectedTags.length) {
            this.selectedTags = this.selectedTags.filter((item) => {
                if (item.deletable === false) {
                    return item;
                }
                this.resetValue(item);
                return undefined;
            });
        }
        if (this.searchKey || this.searchKeyCache) {
            this.searchKey = '';
            this.searchKeyCache = '';
        }
        if (this.currentSelectTag) {
            this.currentSelectTag = undefined;
        }
        this.selectedTagsChange.emit({ selectedTags: this.selectedTags, currentChangeTag: undefined, operation: 'clear' });
        this.clearAllEvent.emit(event);
        this.initCategoryDisplay();
    }
    resolveCategoryDisplay(tag, type) {
        if (tag.field === 'devuiCategorySearchKeyword' || !this.categoryDictionary[tag.field]) {
            return;
        }
        this.handleGroupLength(tag, type === 'delete');
        this.categoryDictionary[tag.field].isSelected = type === 'delete';
    }
    createFilterFn() {
        this.createFilterEvent.emit({ name: this.filterName, selectedTags: this.getSelectedTagsExceptKeyword(), keyword: this.searchKey });
        setTimeout(() => {
            this.filterName = '';
        }, this.DELAY);
    }
    createFilterInputAutoFocus(dropdown, inputElm, filterNameForm) {
        if (dropdown.isOpen) {
            filterNameForm.form.reset();
            setTimeout(() => inputElm.focus());
        }
    }
    searchKeyChangeEvent(event) {
        this.searchKey = event;
        this.enterSearch = !!event;
        this.currentSearchCategory = event ? this.category.filter((item) => item['label'].toLowerCase().includes(event.toLowerCase())) : [];
        this.searchKeyChange.emit(event);
    }
    checkType(tag) {
        return tag && tag.type === 'radio' ? 'all' : 'blank';
    }
    resetValue(tag) {
        tag.value = this.valueIsArrayTypes.includes(tag.type) ? { value: [] } : { value: undefined };
        tag.value[tag.filterKey || 'label'] = undefined;
        return tag;
    }
    afterDropdownClosed() {
        setTimeout(() => {
            this.currentSelectTag = undefined;
        }, this.DROPDOWN_ANIMATION_TIMEOUT + 100);
    }
    /* 各类型模板调用方法 */
    // radio 单选 处理选中项方法
    chooseItem(tag, chooseItem) {
        this.afterDropdownClosed();
        const key = tag.filterKey || 'label';
        tag.value = { value: chooseItem, cache: cloneDeep(chooseItem) };
        tag.value[key] = chooseItem[key];
        tag.title = this.setTitle(tag, 'radio');
        this.updateSelectedTags(tag);
    }
    // date 改变输入值相应变化
    dateChange(datepicker, tag) {
        const index = datepicker.currentActiveInput === 'start' ? 0 : 1;
        const dateFormat = tag.showTime ? 'y/MM/dd HH:mm:ss' : 'y/MM/dd';
        const targetDate = datepicker.dateValue[index];
        const inputDate = datepicker.datepickerConvert.parse(targetDate);
        const valueFormat = inputDate && !isNaN(inputDate.getTime()) && datepicker.datepickerConvert.format(inputDate, dateFormat);
        if (targetDate === valueFormat) {
            tag.value.value[index] = inputDate;
            if (tag.showTime) {
                datepicker.pickerSrv.updateTimeChange.next({
                    activeInput: datepicker.currentActiveInput,
                    hour: inputDate.getHours(),
                    min: inputDate.getMinutes(),
                    seconds: inputDate.getSeconds(),
                });
            }
        }
    }
    confirmDate(datepicker, tag, dropdown) {
        if (!tag.value.value) {
            return;
        }
        if (datepicker.currentActiveInput === 'start') {
            datepicker.focusChange('end');
        }
        else if (!tag.value.value[0]) {
            datepicker.focusChange('start');
        }
        else if (tag.value.value.length > 1) {
            this.closeMenu(dropdown);
            this.afterDropdownClosed();
            const start = tag.value.value[0];
            const end = tag.value.value[1];
            tag.value.cache = cloneDeep(tag.value.value);
            tag.value[tag.filterKey || 'label'] = tag.showTime
                ? `${this.dateConverter.formatDateTime(start)} - ${this.dateConverter.formatDateTime(end)}`
                : `${this.dateConverter.format(start)} - ${this.dateConverter.format(end)}`;
            tag.title = this.setTitle(tag, 'dateRange');
            this.updateSelectedTags(tag);
        }
    }
    // checkbox | label 多选 处理选中项方法
    chooseItems(tag) {
        this.afterDropdownClosed();
        const key = tag.filterKey || 'label';
        const result = this.getItemValue(tag.value.value, key);
        if (result) {
            tag.title = this.setTitle(tag, 'checkbox', result);
            tag.value[key] = result;
            tag.value.cache = cloneDeep(tag.value.value);
            this.updateSelectedTags(tag);
        }
        else {
            this.removeTag(tag);
        }
    }
    // checkbox | label 将选中项对应filterKey的值合并的方法
    getItemValue(value, key) {
        if (value && Array.isArray(value)) {
            const result = value.map((item) => item[key]);
            return result.join(' | ');
        }
    }
    // checkbox | label 当下拉菜单展开重置多选的选中状态
    resetContent(dropdown, tag) {
        const tagItem = tag || this.currentSelectTag || { type: '', options: [] };
        if (this.blurTimer) {
            clearTimeout(this.blurTimer);
        }
        if (this.toggleEvent) {
            this.toggleEvent(dropdown, tag, this.currentSelectTag);
        }
        if (dropdown.isOpen) {
            this.currentOpenDropdown = dropdown;
            if (tag?.type === 'keyword') {
                this.searchKey = this.searchKeyCache;
                this.searchKeyChangeEvent(this.searchKey);
                this.inputEle.nativeElement.focus();
                dropdown.isOpen = false;
            }
        }
        else {
            this.clearCurrentSelectTagFromSearch();
            this.currentOpenDropdown = undefined;
            this.showNoDataTips = false;
            this.resetTreeRender(dropdown, tagItem, false);
            return;
        }
        if (tag && tag !== this.currentSelectTag) {
            this.scrollToTailFlag = false;
            this.resetTreeRender(dropdown, tagItem, true);
            if (!isEqual(tag.value.value, tag.value.cache)) {
                tag.value.value = cloneDeep(tag.value.cache);
                this.handleAccordingType(tag.type, tag.value.options);
            }
        }
        else if (this.currentSelectTag) {
            // checkbox 值不是必须数组，但重置时需空数组才能触发，undefined 不行
            this.currentSelectTag.value.value = ['checkbox', ...this.valueIsArrayTypes].includes(this.currentSelectTag.type) ? [] : undefined;
            this.resetTreeRender(dropdown, tagItem, true, true);
            this.handleAccordingType(this.currentSelectTag.type, this.currentSelectTag.options);
            this.scrollToTailFlag = true;
        }
        this.showNoDataTips = this.showSearchConfig.noCategoriesAvailableTip ? this.categoryDisplay.every((item) => item.isSelected) : false;
    }
    resetTreeRender(dropdown, tag, flag, isCurrentSelectTag) {
        if (tag.type === 'treeSelect') {
            setTimeout(() => {
                this.treeResetFlag = isCurrentSelectTag ? false : flag;
                if (!flag) {
                    this.treeSearch('');
                    return;
                }
                if (tag.searchable) {
                    const dom = dropdown.menuEl.nativeElement.querySelector('.devui-search-container .devui-search>input');
                    if (dom) {
                        dom.focus();
                    }
                }
            }, this.DELAY);
        }
    }
    showCurrentSearchCategory(tag, inputDropdown) {
        this.isSearchCategory = true;
        this.searchKey = '';
        this.closeMenu(inputDropdown);
        this.chooseCategory(tag, inputDropdown);
        setTimeout(() => this.checkInputSearching(), this.DELAY);
    }
    clearCurrentSelectTagFromSearch() {
        if (this.currentSelectTag && this.isSearchCategory) {
            this.isSearchCategory = false;
            setTimeout(() => this.finishChoose(), this.DELAY);
        }
    }
    handleAccordingType(type, options) {
        switch (type) {
            case 'treeSelect':
                options = cloneDeep(options);
                break;
            case 'textInput':
                setTimeout(() => {
                    const inputDom = this.document.querySelector('.devui-category-search-type-text-input');
                    if (inputDom) {
                        inputDom.focus();
                    }
                }, this.DROPDOWN_ANIMATION_TIMEOUT);
                break;
            default:
        }
    }
    // label 合并名称和颜色字段赋给tag，待[tag]支持传入对象后可移除
    mergeToLabel(obj) {
        if (obj?.options && Array.isArray(obj.options)) {
            obj.options.forEach((item) => {
                item.$label = `${item[obj.filterKey || 'label']}_${item[obj.colorKey || 'color']}`;
            });
        }
        return obj;
    }
    // label 拆分名称和颜色用于下拉选项显示
    splitLabel(key, value) {
        // 初始化选中类别生成标签时，value为label的对象，不需要对值进行操作
        if (typeof value !== 'string') {
            return;
        }
        const res = value && value.split('_');
        const obj = res && { label: res[0], color: res[1] };
        return obj && obj[key];
    }
    // textInput 文本输入框 处理选中项方法
    getTextInputValue(tag) {
        this.afterDropdownClosed();
        tag.value[tag.filterKey || 'label'] = tag.value.cache = tag.value.value;
        tag.title = this.setTitle(tag, 'textInput');
        this.updateSelectedTags(tag);
    }
    // numberRange 数字范围 处理选中项方法
    getNumberRangeValue(tag) {
        this.afterDropdownClosed();
        const startNum = tag.value.value[0] || 0;
        const endNum = tag.value.value[1] || 0;
        tag.value.value = [startNum, endNum];
        tag.value.cache = [startNum, endNum];
        tag.value[tag.filterKey || 'label'] = `${startNum} - ${endNum}`;
        tag.title = this.setTitle(tag, 'numberRange');
        this.updateSelectedTags(tag);
    }
    // treeSelect 树 处理选中项方法
    getTreeValue(tag, isConfirm = true) {
        if (isConfirm) {
            this.afterDropdownClosed();
        }
        const result = [];
        const selectedIds = [];
        const data = tag.value.value;
        data.forEach((item) => {
            result.push(item[tag.filterKey || tag.treeNodeTitleKey || 'title']);
            selectedIds.push(item[tag.treeNodeIdKey || 'id']);
        });
        if (result.length) {
            tag.value.options = isConfirm ? cloneDeep(tag.options) : this.initTreeChecked(tag, tag.options, selectedIds);
            tag.value.cache = cloneDeep(tag.value.value);
            tag.value[tag.filterKey || 'label'] = result.join(',');
            tag.title = this.setTitle(tag, 'treeSelect');
        }
        else {
            this.removeTag(tag);
            return;
        }
        if (isConfirm) {
            this.updateTreeChecked(tag, selectedIds);
            this.updateSelectedTags(tag);
        }
    }
    initTreeChecked(tag, tree, selectedIds) {
        if (Array.isArray(tree)) {
            return tree.map((item) => this.initTreeChecked(tag, item, selectedIds));
        }
        else if (tree) {
            const idKey = tag.treeNodeIdKey || 'id';
            const childKey = tag.treeNodeChildrenKey || 'children';
            if (Array.isArray(tree[childKey])) {
                let checkedChild = 0;
                tree[childKey] = this.initTreeChecked(tag, tree[childKey], selectedIds);
                tree[childKey].forEach((child) => child.isChecked && checkedChild++);
                tree.halfChecked = checkedChild > 0 && checkedChild < tree[childKey].length;
                tree.isChecked = checkedChild > 0 && !tree.halfChecked;
            }
            else {
                tree.isChecked = selectedIds.includes(tree[idKey]);
            }
            return tree;
        }
    }
    updateTreeChecked(tag, selectedIds) {
        if (tag.multiple) {
            const halfCheckedIds = [];
            this.treeInstance.nodes.forEach((item) => item.data.halfChecked && halfCheckedIds.push(item.id));
            this.updateTreeData(tag, tag.value.options, selectedIds, halfCheckedIds);
        }
    }
    updateTreeData(tag, data, selectedIds, halfCheckedIds) {
        data.forEach((item) => {
            const itemId = item[tag.treeNodeIdKey || 'id'];
            const childData = item[tag.treeNodeChildrenKey || 'children'];
            item.isChecked = selectedIds.includes(itemId);
            item.halfChecked = halfCheckedIds.includes(itemId);
            if (childData && childData.length) {
                this.updateTreeData(tag, childData, selectedIds, halfCheckedIds);
            }
        });
    }
    onOperableNodeChecked(selectedNodes, tag) {
        const selectedValueExtractor = (nodes) => {
            return tag.leafOnly
                ? nodes.filter((node) => !node.data.isParent).map((node) => node.data.originItem)
                : nodes.map((node) => node.data.originItem);
        };
        if (tag.multiple) {
            tag.value.value = selectedValueExtractor(selectedNodes);
        }
    }
    onOperableNodeSelected(selectedNode, tag) {
        if (tag.multiple || (tag.leafOnly && selectedNode.data.isParent)) {
            return;
        }
        if (selectedNode.data.isActive) {
            tag.value.value = [selectedNode.data.originItem];
            this.getTreeValue(tag);
        }
        else {
            selectedNode.data.isActive = true;
        }
    }
    treeSearch(value, searchFn) {
        this.treeSearchKey = value;
        if (this.treeInstance) {
            const searchRes = searchFn
                ? searchFn(this.treeSearchKey, this.treeInstance)
                : this.treeInstance.treeFactory.searchTree(this.treeSearchKey, true);
            if (typeof searchRes === 'boolean') {
                this.treeNoRecord = searchRes;
            }
            else if (Array.isArray(searchRes)) {
                this.treeNoRecord = searchRes.every((res) => !res);
            }
            this.treeInstance.treeFactory.getFlattenNodes();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: CategorySearchComponent, deps: [{ token: i1.DevConfigService }, { token: DOCUMENT }, { token: i2.I18nService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.3", type: CategorySearchComponent, selector: "d-category-search", inputs: { category: "category", defaultSearchField: "defaultSearchField", selectedTags: "selectedTags", allowClear: "allowClear", allowSave: "allowSave", allowShowMore: "allowShowMore", extendedConfig: "extendedConfig", toggleScrollToTail: "toggleScrollToTail", searchKey: "searchKey", placeholderText: "placeholderText", inputReadOnly: "inputReadOnly", showSearchCategory: "showSearchCategory", categoryInGroup: "categoryInGroup", groupOrderConfig: "groupOrderConfig", customGroupNameTemplate: "customGroupNameTemplate", customCategoryNameTemplate: "customCategoryNameTemplate", tagMaxWidth: "tagMaxWidth", textConfig: "textConfig", filterNameRules: "filterNameRules", beforeTagChange: "beforeTagChange", toggleEvent: "toggleEvent", styleType: "styleType", showGlowStyle: "showGlowStyle" }, outputs: { searchEvent: "searchEvent", selectedTagsChange: "selectedTagsChange", createFilterEvent: "createFilterEvent", clearAllEvent: "clearAllEvent", searchKeyChange: "searchKeyChange" }, host: { properties: { "class.devui-glow-style": "this.hasGlowStyle" } }, queries: [{ propertyName: "contentTemplates", predicate: ContentTemplateDirective }], viewQueries: [{ propertyName: "inputEle", first: true, predicate: ["InputEle"], descendants: true, static: true }, { propertyName: "scrollBarContainer", first: true, predicate: ["ScrollBarContainer"], descendants: true, static: true }, { propertyName: "primeContainer", first: true, predicate: ["PrimeContainer"], descendants: true, static: true }, { propertyName: "treeInstance", first: true, predicate: ["OperableTree"], descendants: true }, { propertyName: "selectedDropdownList", predicate: ["selectedDropdown"], descendants: true }, { propertyName: "defaultTemplates", predicate: DefaultTemplateDirective, descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div\r\n  #PrimeContainer\r\n  class=\"devui-category-search-container devui-category-search-id-{{ id }}\"\r\n  [ngClass]=\"{ 'container-hover': isHover && !isFocus, 'devui-gray-style': styleType === 'gray' }\"\r\n  (mouseenter)=\"isHover = true\"\r\n  (mouseleave)=\"isHover = false\"\r\n>\r\n  <div class=\"devui-category-search-icon\" (click)=\"searchInputValue()\">\r\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" class=\"svg-icon-search\">\r\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n        <path\r\n          d=\"M7,0 C10.8659932,0 14,3.13400675 14,7 C14,8.57190212 13.4818819,10.0227913 12.6071076,11.1912056 L15.7071068,14.2928932 C16.0976311,14.6834175 16.0976311,15.3165825 15.7071068,15.7071068 C15.3466228,16.0675907 14.7793918,16.0953203 14.3871006,15.7902954 L14.2928932,15.7071068 L11.1912056,12.6071076 C10.0227913,13.4818819 8.57190212,14 7,14 C3.13400675,14 5.5067062e-14,10.8659932 5.5067062e-14,7 C5.5067062e-14,3.13400675 3.13400675,0 7,0 Z M7,2 C4.23857625,2 2,4.23857625 2,7 C2,9.76142375 4.23857625,12 7,12 C9.76142375,12 12,9.76142375 12,7 C12,4.23857625 9.76142375,2 7,2 Z\"\r\n          fill=\"#71757F\"\r\n        ></path>\r\n      </g>\r\n    </svg>\r\n  </div>\r\n  <div #ScrollBarContainer class=\"devui-category-search-line-container\">\r\n    <ul class=\"devui-category-search-line\">\r\n      <li\r\n        class=\"devui-tag-item\"\r\n        *ngFor=\"let item of selectedTags\"\r\n        #selectedDropdown=\"d-dropdown\"\r\n        dDropDown\r\n        appendToBody\r\n        dDropDownToggle\r\n        [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\r\n        [closeScope]=\"checkType(item)\"\r\n        (toggleEvent)=\"resetContent(selectedDropdown, item)\"\r\n      >\r\n        <ng-template\r\n          [ngTemplateOutlet]=\"joinLabelTypesTemplate\"\r\n          [ngTemplateOutletContext]=\"{ item: item, isJoinLabelType: joinLabelTypes.includes(item.type) }\"\r\n        ></ng-template>\r\n        <div dDropDownMenu class=\"devui-dropdown-menu devui-dropdown-menu-fix\" [ngClass]=\"{ 'max-height': item.type !== 'treeSelect' }\">\r\n          <ng-template\r\n            [ngTemplateOutlet]=\"item.customTemplate || templates[item.type]\"\r\n            [ngTemplateOutletContext]=\"{ tagOption: item, dropdown: selectedDropdown, isSelected: true }\"\r\n          ></ng-template>\r\n        </div>\r\n      </li>\r\n      <div class=\"devui-category-search-input\">\r\n        <div\r\n          class=\"devui-input-container\"\r\n          #inputDropdown=\"d-dropdown\"\r\n          dDropDown\r\n          appendToBody\r\n          [trigger]=\"'manually'\"\r\n          [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\r\n          [closeScope]=\"checkType(currentSelectTag)\"\r\n          (toggleEvent)=\"resetContent(inputDropdown)\"\r\n        >\r\n          <div style=\"width: 100%\">\r\n            <input\r\n              class=\"devui-category-search-toggle\"\r\n              autocomplete=\"off\"\r\n              #InputEle\r\n              dDropDownToggle\r\n              [readOnly]=\"inputReadOnly\"\r\n              [placeholder]=\"placeholderText || i18nCategorySearchText?.searchPlaceholder || ''\"\r\n              [maxlength]=\"showSearchConfig.searchInputMaxLength\"\r\n              [ngModel]=\"searchKey\"\r\n              (ngModelChange)=\"searchKeyChangeEvent($event)\"\r\n              (click)=\"openMenu(inputDropdown, $event)\"\r\n              (keyup)=\"checkInputSearching(); openMenu(inputDropdown, $event)\"\r\n              (keydown.backspace)=\"backspaceEvent(inputDropdown)\"\r\n              (keydown.enter)=\"searchInputValue($event); closeMenu(inputDropdown)\"\r\n              (focus)=\"isHover = false; isFocus = true\"\r\n              (blur)=\"isFocus = false; blurInput($event)\"\r\n            />\r\n          </div>\r\n          <div\r\n            *ngIf=\"!enterSearch || (enterSearch && showSearchCategory)\"\r\n            dDropDownMenu\r\n            class=\"devui-dropdown-menu devui-dropdown-menu-fix devui-scrollbar devui-category-dropdown-menu-{{ id }}\"\r\n            [ngClass]=\"{ 'max-height': currentSelectTag?.type !== 'treeSelect' }\"\r\n          >\r\n            <ul *ngIf=\"!currentSelectTag\" class=\"devui-dropdown-menu-template devui-scrollbar\">\r\n              <ng-container *ngIf=\"!enterSearch && !currentSelectTag\">\r\n                <ng-container *ngFor=\"let item of categoryDisplay\">\r\n                  <li *ngIf=\"item.groupLength\" class=\"devui-dropdown-item devui-category-search-group\">\r\n                    <ng-template\r\n                      [ngTemplateOutlet]=\"customGroupNameTemplate || defaultGroupNameTemplate\"\r\n                      [ngTemplateOutletContext]=\"{ tag: item }\"\r\n                    ></ng-template>\r\n                  </li>\r\n                  <li\r\n                    *ngIf=\"item.groupLength === undefined && !item.isSelected\"\r\n                    class=\"devui-dropdown-item\"\r\n                    (click)=\"chooseCategory(item, inputDropdown); closeMenu(inputDropdown)\"\r\n                  >\r\n                    <ng-template\r\n                      [ngTemplateOutlet]=\"customCategoryNameTemplate || defaultCategoryNameTemplate\"\r\n                      [ngTemplateOutletContext]=\"{ tag: item }\"\r\n                    ></ng-template>\r\n                  </li>\r\n                </ng-container>\r\n                <div class=\"devui-no-data-text\" *ngIf=\"showNoDataTips\">\r\n                  {{ textConfig.noCategoriesAvailable || i18nCategorySearchText?.noFilterConditions }}\r\n                </div>\r\n              </ng-container>\r\n              <ng-container *ngIf=\"enterSearch\">\r\n                <li\r\n                  *ngIf=\"showSearchConfig.keyword\"\r\n                  class=\"devui-dropdown-item devui-search-description\"\r\n                  (click)=\"searchInputValue($event); closeMenu(inputDropdown)\"\r\n                >\r\n                  <span class=\"icon-search\"></span>{{ showSearchConfig.keywordDescription(searchKey) }}\r\n                </li>\r\n                <ng-container *ngIf=\"showSearchConfig.field\">\r\n                  <li *ngFor=\"let item of searchField\" (click)=\"searchCategory(item); closeMenu(inputDropdown)\" class=\"devui-dropdown-item\">\r\n                    <span class=\"icon-search\"></span>{{ showSearchConfig.fieldDescription(item?.label) }}\r\n                  </li>\r\n                </ng-container>\r\n                <div\r\n                  *ngIf=\"(showSearchConfig.keyword || showSearchConfig.field) && showSearchConfig.category && currentSearchCategory?.length\"\r\n                  class=\"devui-dividing-line\"\r\n                ></div>\r\n                <ng-container *ngIf=\"showSearchConfig.category && currentSearchCategory?.length\">\r\n                  <div class=\"devui-dropdown-menu-tip\" [style.paddingBottom]=\"currentSearchCategory.length ? '0' : '12px'\">\r\n                    {{ showSearchConfig.categoryDescription }}\r\n                  </div>\r\n                  <ul class=\"devui-category-search-keyword-in-category devui-dropdown-menu-template devui-scrollbar\">\r\n                    <li\r\n                      *ngFor=\"let item of currentSearchCategory\"\r\n                      (click)=\"showCurrentSearchCategory(item, inputDropdown)\"\r\n                      class=\"devui-dropdown-item\"\r\n                    >\r\n                      <span>{{ item?.label }}</span>\r\n                    </li>\r\n                  </ul>\r\n                </ng-container>\r\n              </ng-container>\r\n            </ul>\r\n            <ng-container *ngIf=\"!enterSearch && currentSelectTag\">\r\n              <ng-template\r\n                [ngTemplateOutlet]=\"currentSelectTag.customTemplate || templates[currentSelectTag.type]\"\r\n                [ngTemplateOutletContext]=\"{ tagOption: currentSelectTag, dropdown: inputDropdown }\"\r\n              ></ng-template>\r\n            </ng-container>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </ul>\r\n  </div>\r\n  <div class=\"devui-category-search-extended-container\" *ngIf=\"showExtendedConfig\">\r\n    <ng-template *ngIf=\"operationConfig.clear.show\" [ngTemplateOutlet]=\"operationConfig.clear.template || clearTpl\"></ng-template>\r\n    <ng-template *ngIf=\"operationConfig.save.show\" [ngTemplateOutlet]=\"operationConfig.save.template || saveTpl\"></ng-template>\r\n    <ng-template *ngIf=\"operationConfig.more.show\" [ngTemplateOutlet]=\"operationConfig.more.template || moreTpl\"></ng-template>\r\n    <ng-template *ngIf=\"operationConfig.customTemplate\" [ngTemplateOutlet]=\"operationConfig.customTemplate\"></ng-template>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #defaultGroupNameTemplate let-item=\"tag\">\r\n  <strong>{{ item?.groupName }}</strong>\r\n</ng-template>\r\n\r\n<ng-template #defaultCategoryNameTemplate let-item=\"tag\">\r\n  <span title=\"{{ item?.label }}\">{{ item?.label }}</span>\r\n</ng-template>\r\n\r\n<ng-template #noData>\r\n  <div class=\"devui-no-data-tip\">{{ i18nCommonText?.noData }}</div>\r\n</ng-template>\r\n\r\n<ng-template #clearTpl>\r\n  <div\r\n    class=\"devui-category-search-icon\"\r\n    [class.disabled]=\"operationConfig.clear.disabled\"\r\n    (click)=\"!operationConfig.clear.disabled && clearFilter($event)\"\r\n  >\r\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\">\r\n      <title>{{ i18nCategorySearchText?.clearFilterCondition }}</title>\r\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n        <path\r\n          d=\"M4.61289944,3.20970461 L4.70710678,3.29289322 L8,6.585 L11.2928932,3.29289322 C11.6834175,2.90236893 12.3165825,2.90236893 12.7071068,3.29289322 C13.0675907,3.65337718 13.0953203,4.22060824 12.7902954,4.61289944 L12.7071068,4.70710678 L9.415,8 L12.7071068,11.2928932 C13.0976311,11.6834175 13.0976311,12.3165825 12.7071068,12.7071068 C12.3466228,13.0675907 11.7793918,13.0953203 11.3871006,12.7902954 L11.2928932,12.7071068 L8,9.415 L4.70710678,12.7071068 C4.31658249,13.0976311 3.68341751,13.0976311 3.29289322,12.7071068 C2.93240926,12.3466228 2.90467972,11.7793918 3.20970461,11.3871006 L3.29289322,11.2928932 L6.585,8 L3.29289322,4.70710678 C2.90236893,4.31658249 2.90236893,3.68341751 3.29289322,3.29289322 C3.65337718,2.93240926 4.22060824,2.90467972 4.61289944,3.20970461 Z\"\r\n          fill-rule=\"nonzero\"\r\n        ></path>\r\n      </g>\r\n    </svg>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #saveTpl>\r\n  <div\r\n    class=\"devui-category-search-icon\"\r\n    #saveDropdown=\"d-dropdown\"\r\n    dDropDown\r\n    appendToBody\r\n    [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\r\n    [class.disabled]=\"operationConfig.save.disabled\"\r\n    [closeScope]=\"'blank'\"\r\n    [disabled]=\"operationConfig.save.disabled\"\r\n    (toggleEvent)=\"createFilterInputAutoFocus(saveDropdown, createFilterInput, filterNameForm)\"\r\n  >\r\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" version=\"1.1\" dDropDownToggle>\r\n      <title>{{ textConfig.createFilter }}</title>\r\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n        <path\r\n          d=\"M12,1 L15,4 L15,13 C15,14.1045695 14.1045695,15 13,15 L3,15 C1.8954305,15 1,14.1045695 1,13 L1,3 C1,1.8954305 1.8954305,1 3,1 L12,1 Z M11.171,3 L3,3 L3,13 L4,13 L4,10 C4,9.48716416 4.38604019,9.06449284 4.88337887,9.00672773 L5,9 L11,9 C11.5128358,9 11.9355072,9.38604019 11.9932723,9.88337887 L12,10 L12,13 L13,13 L13,4.829 L11.171,3 Z M9.999,10.999 L5.999,10.999 L6,13 L10,13 L9.999,10.999 Z M7,5 C7.55228475,5 8,5.44771525 8,6 C8,6.55228475 7.55228475,7 7,7 L5,7 C4.44771525,7 4,6.55228475 4,6 C4,5.44771525 4.44771525,5 5,5 L7,5 Z\"\r\n          fill-rule=\"nonzero\"\r\n        ></path>\r\n      </g>\r\n    </svg>\r\n    <div dDropDownMenu class=\"devui-save-panel\">\r\n      <div class=\"devui-save-panel-title\">\r\n        <span>{{ textConfig.createFilter }}</span>\r\n      </div>\r\n      <div class=\"devui-save-filter-name\">\r\n        <span>{{ textConfig.filterTitle }}</span>\r\n        <form #filterNameForm=\"ngForm\">\r\n          <input\r\n            name=\"filter-name\"\r\n            class=\"devui-category-search-toggle\"\r\n            autocomplete=\"off\"\r\n            #createFilterInput\r\n            dTextInput\r\n            [(ngModel)]=\"filterName\"\r\n            [placeholder]=\"i18nCategorySearchText?.placeholder || ''\"\r\n            [dValidateRules]=\"filterNameRules\"\r\n          />\r\n          <svg\r\n            *ngIf=\"showFilterNameClear\"\r\n            (click)=\"$event.preventDefault(); $event.stopPropagation(); filterNameForm.form.reset()\"\r\n            width=\"16px\"\r\n            height=\"16px\"\r\n            viewBox=\"0 0 16 16\"\r\n          >\r\n            <title>{{ i18nCategorySearchText?.clearFilterCondition }}</title>\r\n            <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n              <path\r\n                d=\"M4.61289944,3.20970461 L4.70710678,3.29289322 L8,6.585 L11.2928932,3.29289322 C11.6834175,2.90236893 12.3165825,2.90236893 12.7071068,3.29289322 C13.0675907,3.65337718 13.0953203,4.22060824 12.7902954,4.61289944 L12.7071068,4.70710678 L9.415,8 L12.7071068,11.2928932 C13.0976311,11.6834175 13.0976311,12.3165825 12.7071068,12.7071068 C12.3466228,13.0675907 11.7793918,13.0953203 11.3871006,12.7902954 L11.2928932,12.7071068 L8,9.415 L4.70710678,12.7071068 C4.31658249,13.0976311 3.68341751,13.0976311 3.29289322,12.7071068 C2.93240926,12.3466228 2.90467972,11.7793918 3.20970461,11.3871006 L3.29289322,11.2928932 L6.585,8 L3.29289322,4.70710678 C2.90236893,4.31658249 2.90236893,3.68341751 3.29289322,3.29289322 C3.65337718,2.93240926 4.22060824,2.90467972 4.61289944,3.20970461 Z\"\r\n                fill-rule=\"nonzero\"\r\n              ></path>\r\n            </g>\r\n          </svg>\r\n        </form>\r\n      </div>\r\n      <div class=\"devui-save-panel-operation-area\">\r\n        <d-button [disabled]=\"filterNameForm.invalid\" (btnClick)=\"createFilterFn(); saveDropdown.toggle()\">{{\r\n          i18nCategorySearchText?.confirm\r\n        }}</d-button>\r\n        <d-button bsStyle=\"common\" (btnClick)=\"saveDropdown.toggle()\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #moreTpl>\r\n  <div\r\n    class=\"devui-category-search-icon\"\r\n    #seeMoreDropdown=\"d-dropdown\"\r\n    dDropDown\r\n    appendToBody\r\n    [alignOrigin]=\"primeContainer\"\r\n    [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\r\n    [class.disabled]=\"operationConfig.more.disabled\"\r\n  >\r\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" dDropDownToggle>\r\n      <title>{{ i18nCategorySearchText?.seeMore }}</title>\r\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n        <path\r\n          d=\"M1,2 L3,2 L3,4 L1,4 L1,2 Z M1,7 L3,7 L3,9 L1,9 L1,7 Z M1,12 L3,12 L3,14 L1,14 L1,12 Z M5,2 L15,2 L15,4 L5,4 L5,2 Z M5,7 L15,7 L15,9 L5,9 L5,7 Z M5,12 L15,12 L15,14 L5,14 L5,12 Z\"\r\n          fill-rule=\"nonzero\"\r\n        ></path>\r\n      </g>\r\n    </svg>\r\n    <div dDropDownMenu class=\"devui-selected-tags-list\">\r\n      <ul [ngStyle]=\"{ width: PrimeContainer?.clientWidth + 'px' }\">\r\n        <li class=\"devui-tag-item\" *ngFor=\"let item of selectedTags; let i = index\" (click)=\"scrollToTag(i, $event)\">\r\n          <ng-template\r\n            [ngTemplateOutlet]=\"joinLabelTypesTemplate\"\r\n            [ngTemplateOutletContext]=\"{ item: item, isJoinLabelType: joinLabelTypes.includes(item.type) }\"\r\n          ></ng-template>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #joinLabelTypesTemplate let-item=\"item\" let-isJoinLabelType=\"isJoinLabelType\">\r\n  <div class=\"devui-tag-container\">\r\n    <d-tag\r\n      [tag]=\"item\"\r\n      [deletable]=\"item.deletable === false ? false : true\"\r\n      [titleContent]=\"item.title\"\r\n      [customViewTemplate]=\"item.tagCustomTemplate || (isJoinLabelType ? defaultJoinLabelTypeTemplate : defaultTagTemplate)\"\r\n      (tagDelete)=\"removeTag(item, $event.event)\"\r\n    ></d-tag>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #defaultTagTemplate let-tag=\"tag\">\r\n  <span [style.maxWidth]=\"tagMaxWidth + 'px'\">{{ tag.label + ': ' + (tag.value[tag.filterKey || 'label'] || '') }}</span>\r\n</ng-template>\r\n\r\n<ng-template #defaultJoinLabelTypeTemplate let-tag=\"tag\" let-colorKey=\"tag.colorKey || 'color'\">\r\n  <span>{{ tag.label }}: </span>\r\n  <span class=\"devui-category-search-multi-tag\" [style.max-width]=\"tagMaxWidth + 'px'\">\r\n    <ng-container *ngFor=\"let val of tag.value.cache; let i = index\">\r\n      <span *ngIf=\"i > 0\" class=\"devui-color-block-split-line\">{{ textConfig.labelConnector || '|' }}</span>\r\n      <span *ngIf=\"tag.type === 'label'\" class=\"devui-color-block-sm\" [style.background]=\"val[colorKey]\"></span>\r\n      <span [style.color]=\"val[colorKey]\" [style.max-width]=\"tagMaxWidth + 'px'\">{{ val[tag.filterKey || 'label'] || '' }}</span>\r\n    </ng-container>\r\n  </span>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'radio'\" let-tagOption=\"tagOption\" let-key=\"tagOption.filterKey || 'label'\">\r\n  <div *ngIf=\"!tagOption.options?.length\">\r\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\r\n  </div>\r\n  <ul *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template devui-scrollbar\">\r\n    <li\r\n      *ngFor=\"let item of tagOption.options\"\r\n      title=\"{{ item[key] }}\"\r\n      class=\"devui-dropdown-item\"\r\n      [class.active]=\"tagOption?.value[key] === item[key]\"\r\n      (click)=\"chooseItem(tagOption, item)\"\r\n    >\r\n      <span>{{ item[key] }}</span>\r\n    </li>\r\n  </ul>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'dateRange'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <d-datepicker-calendar\r\n    #datepickerCalendarItem\r\n    *ngIf=\"dropdown.isOpen\"\r\n    id=\"{{ tagOption.field }}\"\r\n    style=\"overflow-x: hidden\"\r\n    #dDatepickerPro\r\n    [isRangeType]=\"true\"\r\n    [showTime]=\"tagOption.showTime\"\r\n    [activeRangeType]=\"tagOption.activeRangeType || 'start'\"\r\n    [(ngModel)]=\"tagOption.value.value\"\r\n    (input)=\"dateChange(datepickerCalendarItem, tagOption)\"\r\n  >\r\n    <ng-template #footerTemplate>\r\n      <div class=\"devui-datepicker-footer\">\r\n        <d-button\r\n          style=\"margin-right: 8px\"\r\n          bsStyle=\"primary\"\r\n          (btnClick)=\"confirmDate(datepickerCalendarItem, tagOption, dropdown)\"\r\n          [disabled]=\"\r\n            tagOption.showTime ? false : !tagOption.value.value || tagOption.value.value.length < 2 || tagOption.value.value.includes(null)\r\n          \"\r\n        >\r\n          {{ i18nCategorySearchText?.confirm }}\r\n        </d-button>\r\n        <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n      </div>\r\n    </ng-template>\r\n  </d-datepicker-calendar>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'checkbox'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <div *ngIf=\"!tagOption.options?.length\">\r\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\r\n  </div>\r\n  <div *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template devui-scrollbar\">\r\n    <d-checkbox-group\r\n      [(ngModel)]=\"tagOption.value.value\"\r\n      [options]=\"tagOption.options\"\r\n      [filterKey]=\"tagOption.filterKey || 'label'\"\r\n      [isShowTitle]=\"true\"\r\n    >\r\n    </d-checkbox-group>\r\n  </div>\r\n  <div class=\"devui-dropdown-operation-area\">\r\n    <d-button (btnClick)=\"chooseItems(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'label'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <div *ngIf=\"!tagOption.options?.length\">\r\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\r\n  </div>\r\n  <div *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template devui-scrollbar\">\r\n    <d-checkbox-group\r\n      [(ngModel)]=\"tagOption.value.value\"\r\n      [options]=\"tagOption.options\"\r\n      [filterKey]=\"'$label'\"\r\n      [labelTemplate]=\"labelContent\"\r\n      [isShowTitle]=\"true\"\r\n    >\r\n      <ng-template #labelContent let-label=\"label\">\r\n        <span class=\"devui-color-block\" [style.background]=\"splitLabel('color', label)\" title=\"{{ splitLabel('label', label) }}\"></span>\r\n        <span title=\"{{ splitLabel('label', label) }}\">{{ splitLabel('label', label) }}</span>\r\n      </ng-template>\r\n    </d-checkbox-group>\r\n  </div>\r\n  <div class=\"devui-dropdown-operation-area\">\r\n    <d-button (btnClick)=\"chooseItems(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'textInput'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <form #textInputForm=\"ngForm\">\r\n    <input\r\n      name=\"text-input\"\r\n      class=\"devui-category-search-type-text-input\"\r\n      autocomplete=\"off\"\r\n      dTextInput\r\n      [(ngModel)]=\"tagOption.value.value\"\r\n      [maxlength]=\"tagOption.maxLength\"\r\n      [placeholder]=\"tagOption.placeholder || ''\"\r\n      [dValidateRules]=\"tagOption.validateRules\"\r\n    />\r\n  </form>\r\n  <div class=\"devui-dropdown-operation-area\">\r\n    <d-button [disabled]=\"textInputForm.invalid\" (btnClick)=\"getTextInputValue(tagOption); closeMenu(dropdown)\">{{\r\n      i18nCategorySearchText?.confirm\r\n    }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'numberRange'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <div class=\"devui-input-number-operation-area\">\r\n    <d-input-number\r\n      size=\"sm\"\r\n      [min]=\"tagOption.min?.left\"\r\n      [max]=\"tagOption.max?.left\"\r\n      [maxLength]=\"tagOption.maxLength?.left\"\r\n      [step]=\"tagOption.step?.left || 1\"\r\n      [reg]=\"tagOption.reg?.left\"\r\n      [placeholder]=\"tagOption.placeholder?.left || ''\"\r\n      [(ngModel)]=\"tagOption.value.value[0]\"\r\n    >\r\n    </d-input-number>\r\n    <span> - </span>\r\n    <d-input-number\r\n      size=\"sm\"\r\n      [min]=\"tagOption.min?.right\"\r\n      [max]=\"tagOption.max?.right\"\r\n      [maxLength]=\"tagOption.maxLength?.right\"\r\n      [step]=\"tagOption.step?.right || 1\"\r\n      [reg]=\"tagOption.reg?.right\"\r\n      [placeholder]=\"tagOption.placeholder?.right || ''\"\r\n      [(ngModel)]=\"tagOption.value.value[1]\"\r\n    >\r\n    </d-input-number>\r\n  </div>\r\n  <div class=\"devui-dropdown-operation-area\">\r\n    <d-button (btnClick)=\"getNumberRangeValue(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'treeSelect'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\" let-isSelected=\"isSelected\">\r\n  <div *ngIf=\"tagOption.multiple && tagOption.options?.length && tagOption.value.value?.length\">\r\n    <ul class=\"devui-select-list\">\r\n      <span>{{ i18nCategorySearchText?.selected }}</span>\r\n      <li class=\"devui-select-item devui-no-label-item\" *ngFor=\"let item of tagOption.value.value; last as isLast\">\r\n        {{ item[tagOption.filterKey || tagOption.treeNodeTitleKey || 'title'] }}\r\n        <span *ngIf=\"!isLast\">, </span>\r\n      </li>\r\n    </ul>\r\n  </div>\r\n  <div *ngIf=\"tagOption.searchable\" class=\"devui-search-container\">\r\n    <d-search\r\n      [placeholder]=\"tagOption.searchPlaceholder\"\r\n      [ngModel]=\"treeSearchKey\"\r\n      (ngModelChange)=\"treeSearch($event, tagOption.searchFn)\"\r\n    ></d-search>\r\n  </div>\r\n  <div class=\"devui-category-search-tree-container\" [style.display]=\"tagOption.options?.length && !treeNoRecord ? 'block' : 'none'\">\r\n    <d-operable-tree\r\n      #OperableTree\r\n      *ngIf=\"dropdown.isOpen || treeResetFlag\"\r\n      class=\"devui-tree\"\r\n      [tree]=\"isSelected ? tagOption.value.options : tagOption.options\"\r\n      [treeNodeIdKey]=\"tagOption.treeNodeIdKey || 'id'\"\r\n      [treeNodeChildrenKey]=\"tagOption.treeNodeChildrenKey || 'children'\"\r\n      [treeNodeTitleKey]=\"tagOption.filterKey || tagOption.treeNodeTitleKey || 'title'\"\r\n      [checkboxDisabledKey]=\"tagOption.disabledKey || 'disabled'\"\r\n      [checkable]=\"tagOption.multiple\"\r\n      [canActivateNode]=\"!tagOption.multiple\"\r\n      [canActivateParentNode]=\"!tagOption.leafOnly\"\r\n      [iconParentOpen]=\"tagOption.iconParentOpen || icons.iconParentOpen\"\r\n      [iconParentClose]=\"tagOption.iconParentClose || icons.iconParentClose\"\r\n      [iconLeaf]=\"tagOption.iconLeaf || icons.iconLeaf\"\r\n      (nodeChecked)=\"onOperableNodeChecked($event, tagOption)\"\r\n      (nodeSelected)=\"onOperableNodeSelected($event, tagOption); closeMenu(dropdown)\"\r\n    >\r\n    </d-operable-tree>\r\n  </div>\r\n  <div *ngIf=\"!tagOption.options?.length\">\r\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\r\n  </div>\r\n  <div *ngIf=\"treeNoRecord\" class=\"devui-no-data-tip\">{{ i18nCommonText?.noRecordsFound }}</div>\r\n  <div *ngIf=\"tagOption.multiple\" class=\"devui-dropdown-operation-area\">\r\n    <d-button [disabled]=\"!tagOption.value.value?.length\" (btnClick)=\"getTreeValue(tagOption); closeMenu(dropdown)\">{{\r\n      i18nCategorySearchText?.confirm\r\n    }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n", styles: [".devui-font-size-base{font-size:var(--devui-font-size, 12px)}.devui-font-base{font-size:var(--devui-font-size, 12px);font-weight:var(--devui-font-content-weight, normal);line-height:var(--devui-line-height-base, 1.5)}.devui-font-size-modal-title{font-size:var(--devui-font-size-modal-title, 18px)}.devui-font-modal-title{font-size:var(--devui-font-size-modal-title, 18px);font-weight:var(--devui-font-title-weight, bold);line-height:var(--devui-line-height-base, 1.5)}.devui-font-size-page-title{font-size:var(--devui-font-size-page-title, 16px)}.devui-font-page-title{font-size:var(--devui-font-size-page-title, 16px);font-weight:var(--devui-font-title-weight, bold);line-height:var(--devui-line-height-base, 1.5)}.devui-font-size-secondary-title{font-size:var(--devui-font-size-card-title, 14px)}.devui-font-secondary-title{font-size:var(--devui-font-size-card-title, 14px);font-weight:var(--devui-font-title-weight, bold);line-height:var(--devui-line-height-base, 1.5)}:host:not(.devui-glow-style) .devui-category-search-container.container-hover:hover{border:1px solid var(--devui-form-control-line-hover, #9b9fa8)}.devui-category-search-container{position:relative;border-radius:var(--devui-border-radius, 2px);width:100%;height:32px;padding:0 8px;display:flex;align-items:flex-start;background:transparent;transition:border var(--devui-animation-duration-slow, .3s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1));background-color:var(--devui-base-bg, #ffffff);border:1px solid var(--devui-line, #d7d8da)}.devui-category-search-container.container-hover>.devui-category-search-icon svg g path{fill:var(--devui-icon-fill-hover, #252b3a)}.devui-category-search-container>.devui-category-search-icon{margin-top:6px}.devui-category-search-container.devui-gray-style{background-color:var(--devui-gray-form-control-bg, #f5f5f5);border-color:transparent;transition:all var(--devui-animation-duration-slow, .3s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}.devui-category-search-container.devui-gray-style:hover{background-color:var(--devui-gray-form-control-hover-bg, #ebebeb)}.devui-category-search-container.devui-gray-style:focus-within{background-color:var(--devui-base-bg, #ffffff);border-color:var(--devui-brand, #5e7ce0)}.devui-category-search-container.devui-gray-style .devui-category-search-input input.devui-category-search-toggle{background-color:transparent!important}.devui-category-search-container .devui-category-search-toggle{color:var(--devui-text, #252b3a)}.devui-category-search-container .devui-category-search-line-container{width:100%;height:32px;overflow:hidden}.devui-category-search-container .devui-category-search-line-container:hover{overflow-x:auto;overflow-x:overlay}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line{display:flex;flex-flow:row nowrap;justify-content:flex-start;align-items:flex-start;width:100%;height:30px;position:relative;top:-1px}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line>li{display:flex;align-items:center;flex-grow:0;white-space:nowrap;height:100%}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input{display:flex;justify-content:flex-start;flex-grow:1;align-items:center;min-width:160px;padding-right:20px}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input input{min-width:240px;width:100%;height:32px;font-size:var(--devui-font-size-sm, 12px)}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input .devui-category-search-toggle{padding-left:0}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input .devui-category-search-keyword-in-category{overflow:visible}.devui-category-search-container input{border:none;background:transparent}.devui-category-search-container .devui-input-container{display:flex;flex:1}.devui-category-search-container .devui-category-search-extended-container{display:flex;flex-wrap:nowrap;width:fit-content;height:16px;margin:8px 0;border-left:solid 1px var(--devui-line, #d7d8da);padding-left:8px}.devui-category-search-container .devui-category-search-extended-container:empty{border:none;padding-left:0}.devui-tag-item{display:inline-block;margin-right:4px}.devui-tag-item:first-child{margin-left:4px}.devui-tag-item:focus{outline:none}.devui-tag-item .devui-color-block-split-line{color:var(--devui-aide-text, #71757f)}.devui-tag-item .devui-color-block-sm{width:8px;height:8px;border-radius:var(--devui-border-radius, 2px);margin-right:4px;display:inline-block;position:relative;top:-1px;vertical-align:middle}span:focus{outline:none}.devui-category-search-icon{display:flex;padding-right:8px;align-items:center;height:16px;cursor:pointer}.devui-category-search-icon svg g path{outline:none;fill:var(--devui-icon-fill, #71757f);transition:all var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1)) var(--devui-animation-duration-slow, .3s)}.devui-category-search-icon.disabled{cursor:not-allowed}.devui-category-search-icon.disabled svg g path{fill:var(--devui-disabled-text, #babbc0)}.devui-category-search-icon:not(.disabled):hover svg g path{fill:var(--devui-icon-fill-hover, #252b3a)}input,input:focus{outline:none!important}a:focus,a:hover{color:var(--devui-list-item-hover-text, #252b3a)}d-tag{cursor:pointer}.devui-category-search-toggle{height:30px}.devui-date-picker-operation-area{border-top:1px solid var(--devui-dividing-line, #eef0f5);margin:16px 0;padding:16px 16px 0;display:flex;justify-content:flex-end}.devui-date-picker-operation-area d-button:not(:first-child){margin-left:16px}.devui-dropdown-operation-area{border-top:1px solid var(--devui-dividing-line, #eef0f5);padding-top:8px;margin:8px 0;display:flex;justify-content:center}.devui-dropdown-operation-area d-button:first-child{margin-right:8px}.devui-input-number-operation-area{padding:16px 16px 8px;display:flex;justify-content:space-evenly}.devui-save-panel{width:400px;height:auto;margin-top:4px}.devui-save-panel .devui-save-panel-title{display:flex;justify-content:space-between;height:48px;line-height:48px;border-bottom:1px solid var(--devui-dividing-line, #eef0f5);padding:0 20px;font-size:14px;font-weight:700;color:var(--devui-font-size-page-title, 16px)}.devui-save-panel .devui-save-filter-name{padding:16px 20px}.devui-save-panel .devui-save-filter-name>form{position:relative}.devui-save-panel .devui-save-filter-name>form input{padding-right:28px}.devui-save-panel .devui-save-filter-name>form svg{position:absolute;right:8px;top:50%;transform:translateY(-50%);cursor:pointer}.devui-save-panel .devui-save-filter-name>form svg path{fill:var(--devui-icon-fill, #71757f)}.devui-save-panel .devui-save-filter-name>form svg:hover svg g path{fill:var(--devui-icon-fill-hover, #252b3a)}.devui-save-panel .devui-save-filter-name>span{padding-bottom:8px;display:block;line-height:1em}.devui-save-panel .devui-save-filter-name>input{width:100%;height:32px;margin:4px auto;line-height:20px;border:1px solid var(--devui-form-control-line, #d7d8da)}.devui-save-panel .devui-save-panel-operation-area{padding-bottom:12px;display:flex;justify-content:center}.devui-save-panel .devui-save-panel-operation-area d-button:not(:first-child){margin-left:16px}.devui-dropdown-menu-template{max-width:300px;max-height:352px;overflow:auto}.devui-dropdown-menu-template:empty{display:none}.devui-dropdown-menu-template .devui-category-search-group{font-size:var(--devui-font-size, 12px)}.devui-dropdown-menu-template .devui-category-search-group.devui-dropdown-item:hover{background-color:transparent;color:var(--devui-text, #252b3a);cursor:default}.devui-selected-tags-list ul{display:flex;flex-flow:row wrap;align-items:center;justify-content:flex-start;max-height:390px;overflow:auto}.devui-selected-tags-list ul li{display:flex;flex-grow:0;flex-flow:row wrap;margin:2px 4px 2px 0}.devui-selected-tags-list ul li:last-child{margin-right:0}:host ::ng-deep .devui-tag-container{line-height:1}:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item{display:block!important}:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item .devui-category-search-multi-tag>span,:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item>span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:inline-block;vertical-align:middle;margin:0 4px}:host ::ng-deep .devui-checkbox-column-margin{height:32px!important;line-height:32px!important}::ng-deep .cdk-overlay-container d-datepicker[id=devui-category-search-date-picker] .devui-month-view{box-shadow:none!important}::ng-deep .cdk-overlay-container d-datepicker[id=devui-category-search-date-picker] .devui-month-view tfoot{display:none}::ng-deep .cdk-overlay-container .devui-selected-tags-list ul li .remove-button{right:8px}::ng-deep .cdk-overlay-container .devui-tag-container d-tag>.devui-tag-item{display:block!important}::ng-deep .cdk-overlay-container .devui-tag-container d-tag>.devui-tag-item .devui-category-search-multi-tag>span,::ng-deep .cdk-overlay-container .devui-tag-container d-tag>.devui-tag-item>span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:inline-block;vertical-align:middle;margin:0 4px}::ng-deep .devui-dropdown-top .devui-dropdown-menu-fix,::ng-deep .devui-dropdown-bottom .devui-dropdown-menu-fix,::ng-deep .devui-dropdown-open .devui-dropdown-menu-fix{margin-bottom:0}::ng-deep .devui-dropdown-menu-fix{min-width:200px;margin-left:0;overflow-y:auto;white-space:nowrap}::ng-deep .devui-dropdown-menu-fix.max-height{max-height:405px}::ng-deep .devui-dropdown-menu-fix .devui-checkbox-group{padding:8px 12px 0}::ng-deep .devui-dropdown-menu-fix .devui-checkbox-group .devui-color-block{width:12px;height:12px;margin-right:8px;border-radius:var(--devui-border-radius, 2px);top:-1px;position:relative;vertical-align:middle;display:inline-block}::ng-deep .devui-dropdown-menu-fix .devui-category-search-type-text-input{margin:16px 8px 8px;width:calc(100% - 16px)}::ng-deep .devui-dropdown-menu-fix .devui-select-list{display:flex;flex-wrap:wrap;max-width:300px;padding:8px}::ng-deep .devui-dropdown-menu-fix .devui-select-list span{margin-right:8px}::ng-deep .devui-dropdown-menu-fix .devui-search-container d-search{width:100%}::ng-deep .devui-dropdown-menu-fix .devui-search-container d-search .devui-search .devui-input.devui-clear-exit:not(.devui-icon-left){padding-right:28px}::ng-deep .devui-dropdown-menu-fix .devui-category-search-tree-container{overflow-y:auto;max-height:264px;padding:12px}::ng-deep .devui-dropdown-menu-fix .devui-no-data-tip{padding:12px}::ng-deep .devui-dropdown-menu-fix .devui-yearOption,::ng-deep .devui-dropdown-menu-fix .devui-monthOption{white-space:normal}::ng-deep .devui-dropdown-menu-fix d-datepicker-calendar{display:block}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox{margin:0 -8px;padding:0 8px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:hover{background-color:var(--devui-list-item-hover-bg, #f2f2f3)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:hover label{color:var(--devui-list-item-hover-text, #252b3a)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:active{background-color:var(--devui-list-item-active-bg, #e9edfa)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:active label{color:var(--devui-list-item-active-text, #252b3a)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;width:100%}::ng-deep .devui-dropdown-menu-fix d-input-number{width:70px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group ul{max-height:310px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox{transition:background-color var(--devui-animation-duration-fast, .1s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox label{transition:color var(--devui-animation-duration-fast, .1s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}.devui-dropdown-menu-tip{cursor:text;padding:12px 12px 0;pointer-events:none;color:var(--devui-aide-text, #71757f)}.devui-dividing-line{height:1px;width:100%;background-color:var(--devui-dividing-line, #eef0f5);margin-top:4px}.devui-dropdown-menu{margin-top:4px;padding-bottom:0}.devui-dropdown-menu .devui-dropdown-item .icon-search{margin-right:4px}.devui-no-data-text{padding:8px 0;text-align:center}.devui-datepicker-footer{text-align:center}\n"], dependencies: [{ kind: "directive", type: i3.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i3.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i4.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }, { kind: "directive", type: i5.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i5.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i5.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i5.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i5.NgForm, selector: "form:not([ngNoForm]):not([formGroup]),ng-form,[ngForm]", inputs: ["ngFormOptions"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i6.DropDownDirective, selector: "[dDropDown]", inputs: ["isOpen", "disabled", "showAnimation", "trigger", "closeScope", "closeOnMouseLeaveMenu"], outputs: ["toggleEvent"], exportAs: ["d-dropdown"] }, { kind: "directive", type: i6.DropDownMenuDirective, selector: "[dDropDownMenu]", exportAs: ["d-dropdown-menu"] }, { kind: "directive", type: i6.DropDownToggleDirective, selector: "[dDropDownToggle]", inputs: ["toggleOnFocus", "autoFocus"], exportAs: ["d-dropdown-toggle"] }, { kind: "component", type: i6.DropDownAppendToBodyComponent, selector: "[dDropDown][appendToBody]", inputs: ["alignOrigin", "appendToBodyDirections", "appendToBodyScrollStrategy"] }, { kind: "directive", type: i7.TextDirective, selector: "[dTextInput]", inputs: ["error", "size", "styleType", "showGlowStyle"], exportAs: ["dTextInput"] }, { kind: "component", type: i8.SearchComponent, selector: "d-search", inputs: ["size", "placeholder", "maxLength", "isKeyupSearch", "delay", "disabled", "cssClass", "iconPosition", "noBorder", "autoFocus", "styleType", "showGlowStyle"], outputs: ["searchFn"], exportAs: ["search"] }, { kind: "component", type: i9.TagComponent, selector: "d-tag", inputs: ["tag", "labelStyle", "customColor", "deletable", "titleContent", "mode", "checked", "maxWidth", "customViewTemplate", "beforeDelete"], outputs: ["tagDelete", "checkedChange"], exportAs: ["Tag"] }, { kind: "component", type: i10.ButtonComponent, selector: "d-button", inputs: ["id", "type", "bsStyle", "shape", "bsSize", "bsPosition", "bordered", "icon", "disabled", "showLoading", "width", "autofocus", "loadingTemplateRef"], outputs: ["btnClick"] }, { kind: "component", type: i11.CheckBoxGroupComponent, selector: "d-checkbox-group", inputs: ["name", "itemWidth", "color", "direction", "isShowTitle", "disabled", "options", "filterKey", "labelTemplate", "showAnimation", "beforeChange"], outputs: ["change"] }, { kind: "component", type: i12.InputNumberComponent, selector: "d-input-number", inputs: ["step", "disabled", "size", "decimalLimit", "autoFocus", "allowEmpty", "placeholder", "maxLength", "reg", "styleType", "showGlowStyle", "min", "max"], outputs: ["afterValueChanged", "whileValueChanging"] }, { kind: "component", type: i13.OperableTreeComponent, selector: "d-operable-tree", inputs: ["tree", "treeNodeIdKey", "treeNodeChildrenKey", "checkboxDisabledKey", "selectDisabledKey", "toggleDisabledKey", "iconParentOpen", "iconParentClose", "iconLeaf", "showLoading", "loadingTemplateRef", "treeNodesRef", "checkable", "deletable", "addable", "editable", "draggable", "disableMouseEvent", "checkboxInput", "beforeAddNode", "beforeDeleteNode", "beforeEditNode", "beforeSelectNode", "beforeNodeDrop", "canActivateNode", "canActivateParentNode", "canActivateMultipleNode", "treeNodeTitleKey", "postAddNode", "iconTemplatePosition", "virtualScroll", "virtualScrollHeight", "showAnimation", "itemSize", "minBufferPx", "maxBufferPx", "checkableRelation", "indent", "canIdEmpty", "operatorAlign", "dropType"], outputs: ["nodeSelected", "nodeDblClicked", "nodeRightClicked", "nodeToggled", "afterTreeInit", "nodeDeleted", "nodeChecked", "currentNodeChecked", "nodeEdited", "editValueChange", "nodeDragStart", "nodeOnDrop"], exportAs: ["dOperableTreeComponent"] }, { kind: "component", type: i14.DatepickerProCalendarComponent, selector: "d-datepicker-calendar", inputs: ["activeRangeType", "isRangeType", "showTime", "mode", "startIndexOfWeek", "splitter", "showRangeHeader", "placeholder", "allowClear", "minDate", "maxDate", "markedRangeDateList", "markedDateList"], outputs: ["confirmEvent", "cancelEvent"] }, { kind: "directive", type: DefaultTemplateDirective, selector: "ng-template[type], ng-template[dType]", inputs: ["type", "dType"] }] }); }
}
__decorate([
    WithConfig(),
    __metadata("design:type", Object)
], CategorySearchComponent.prototype, "styleType", void 0);
__decorate([
    WithConfig(),
    __metadata("design:type", Object)
], CategorySearchComponent.prototype, "showGlowStyle", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: CategorySearchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'd-category-search', template: "<div\r\n  #PrimeContainer\r\n  class=\"devui-category-search-container devui-category-search-id-{{ id }}\"\r\n  [ngClass]=\"{ 'container-hover': isHover && !isFocus, 'devui-gray-style': styleType === 'gray' }\"\r\n  (mouseenter)=\"isHover = true\"\r\n  (mouseleave)=\"isHover = false\"\r\n>\r\n  <div class=\"devui-category-search-icon\" (click)=\"searchInputValue()\">\r\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" class=\"svg-icon-search\">\r\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n        <path\r\n          d=\"M7,0 C10.8659932,0 14,3.13400675 14,7 C14,8.57190212 13.4818819,10.0227913 12.6071076,11.1912056 L15.7071068,14.2928932 C16.0976311,14.6834175 16.0976311,15.3165825 15.7071068,15.7071068 C15.3466228,16.0675907 14.7793918,16.0953203 14.3871006,15.7902954 L14.2928932,15.7071068 L11.1912056,12.6071076 C10.0227913,13.4818819 8.57190212,14 7,14 C3.13400675,14 5.5067062e-14,10.8659932 5.5067062e-14,7 C5.5067062e-14,3.13400675 3.13400675,0 7,0 Z M7,2 C4.23857625,2 2,4.23857625 2,7 C2,9.76142375 4.23857625,12 7,12 C9.76142375,12 12,9.76142375 12,7 C12,4.23857625 9.76142375,2 7,2 Z\"\r\n          fill=\"#71757F\"\r\n        ></path>\r\n      </g>\r\n    </svg>\r\n  </div>\r\n  <div #ScrollBarContainer class=\"devui-category-search-line-container\">\r\n    <ul class=\"devui-category-search-line\">\r\n      <li\r\n        class=\"devui-tag-item\"\r\n        *ngFor=\"let item of selectedTags\"\r\n        #selectedDropdown=\"d-dropdown\"\r\n        dDropDown\r\n        appendToBody\r\n        dDropDownToggle\r\n        [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\r\n        [closeScope]=\"checkType(item)\"\r\n        (toggleEvent)=\"resetContent(selectedDropdown, item)\"\r\n      >\r\n        <ng-template\r\n          [ngTemplateOutlet]=\"joinLabelTypesTemplate\"\r\n          [ngTemplateOutletContext]=\"{ item: item, isJoinLabelType: joinLabelTypes.includes(item.type) }\"\r\n        ></ng-template>\r\n        <div dDropDownMenu class=\"devui-dropdown-menu devui-dropdown-menu-fix\" [ngClass]=\"{ 'max-height': item.type !== 'treeSelect' }\">\r\n          <ng-template\r\n            [ngTemplateOutlet]=\"item.customTemplate || templates[item.type]\"\r\n            [ngTemplateOutletContext]=\"{ tagOption: item, dropdown: selectedDropdown, isSelected: true }\"\r\n          ></ng-template>\r\n        </div>\r\n      </li>\r\n      <div class=\"devui-category-search-input\">\r\n        <div\r\n          class=\"devui-input-container\"\r\n          #inputDropdown=\"d-dropdown\"\r\n          dDropDown\r\n          appendToBody\r\n          [trigger]=\"'manually'\"\r\n          [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\r\n          [closeScope]=\"checkType(currentSelectTag)\"\r\n          (toggleEvent)=\"resetContent(inputDropdown)\"\r\n        >\r\n          <div style=\"width: 100%\">\r\n            <input\r\n              class=\"devui-category-search-toggle\"\r\n              autocomplete=\"off\"\r\n              #InputEle\r\n              dDropDownToggle\r\n              [readOnly]=\"inputReadOnly\"\r\n              [placeholder]=\"placeholderText || i18nCategorySearchText?.searchPlaceholder || ''\"\r\n              [maxlength]=\"showSearchConfig.searchInputMaxLength\"\r\n              [ngModel]=\"searchKey\"\r\n              (ngModelChange)=\"searchKeyChangeEvent($event)\"\r\n              (click)=\"openMenu(inputDropdown, $event)\"\r\n              (keyup)=\"checkInputSearching(); openMenu(inputDropdown, $event)\"\r\n              (keydown.backspace)=\"backspaceEvent(inputDropdown)\"\r\n              (keydown.enter)=\"searchInputValue($event); closeMenu(inputDropdown)\"\r\n              (focus)=\"isHover = false; isFocus = true\"\r\n              (blur)=\"isFocus = false; blurInput($event)\"\r\n            />\r\n          </div>\r\n          <div\r\n            *ngIf=\"!enterSearch || (enterSearch && showSearchCategory)\"\r\n            dDropDownMenu\r\n            class=\"devui-dropdown-menu devui-dropdown-menu-fix devui-scrollbar devui-category-dropdown-menu-{{ id }}\"\r\n            [ngClass]=\"{ 'max-height': currentSelectTag?.type !== 'treeSelect' }\"\r\n          >\r\n            <ul *ngIf=\"!currentSelectTag\" class=\"devui-dropdown-menu-template devui-scrollbar\">\r\n              <ng-container *ngIf=\"!enterSearch && !currentSelectTag\">\r\n                <ng-container *ngFor=\"let item of categoryDisplay\">\r\n                  <li *ngIf=\"item.groupLength\" class=\"devui-dropdown-item devui-category-search-group\">\r\n                    <ng-template\r\n                      [ngTemplateOutlet]=\"customGroupNameTemplate || defaultGroupNameTemplate\"\r\n                      [ngTemplateOutletContext]=\"{ tag: item }\"\r\n                    ></ng-template>\r\n                  </li>\r\n                  <li\r\n                    *ngIf=\"item.groupLength === undefined && !item.isSelected\"\r\n                    class=\"devui-dropdown-item\"\r\n                    (click)=\"chooseCategory(item, inputDropdown); closeMenu(inputDropdown)\"\r\n                  >\r\n                    <ng-template\r\n                      [ngTemplateOutlet]=\"customCategoryNameTemplate || defaultCategoryNameTemplate\"\r\n                      [ngTemplateOutletContext]=\"{ tag: item }\"\r\n                    ></ng-template>\r\n                  </li>\r\n                </ng-container>\r\n                <div class=\"devui-no-data-text\" *ngIf=\"showNoDataTips\">\r\n                  {{ textConfig.noCategoriesAvailable || i18nCategorySearchText?.noFilterConditions }}\r\n                </div>\r\n              </ng-container>\r\n              <ng-container *ngIf=\"enterSearch\">\r\n                <li\r\n                  *ngIf=\"showSearchConfig.keyword\"\r\n                  class=\"devui-dropdown-item devui-search-description\"\r\n                  (click)=\"searchInputValue($event); closeMenu(inputDropdown)\"\r\n                >\r\n                  <span class=\"icon-search\"></span>{{ showSearchConfig.keywordDescription(searchKey) }}\r\n                </li>\r\n                <ng-container *ngIf=\"showSearchConfig.field\">\r\n                  <li *ngFor=\"let item of searchField\" (click)=\"searchCategory(item); closeMenu(inputDropdown)\" class=\"devui-dropdown-item\">\r\n                    <span class=\"icon-search\"></span>{{ showSearchConfig.fieldDescription(item?.label) }}\r\n                  </li>\r\n                </ng-container>\r\n                <div\r\n                  *ngIf=\"(showSearchConfig.keyword || showSearchConfig.field) && showSearchConfig.category && currentSearchCategory?.length\"\r\n                  class=\"devui-dividing-line\"\r\n                ></div>\r\n                <ng-container *ngIf=\"showSearchConfig.category && currentSearchCategory?.length\">\r\n                  <div class=\"devui-dropdown-menu-tip\" [style.paddingBottom]=\"currentSearchCategory.length ? '0' : '12px'\">\r\n                    {{ showSearchConfig.categoryDescription }}\r\n                  </div>\r\n                  <ul class=\"devui-category-search-keyword-in-category devui-dropdown-menu-template devui-scrollbar\">\r\n                    <li\r\n                      *ngFor=\"let item of currentSearchCategory\"\r\n                      (click)=\"showCurrentSearchCategory(item, inputDropdown)\"\r\n                      class=\"devui-dropdown-item\"\r\n                    >\r\n                      <span>{{ item?.label }}</span>\r\n                    </li>\r\n                  </ul>\r\n                </ng-container>\r\n              </ng-container>\r\n            </ul>\r\n            <ng-container *ngIf=\"!enterSearch && currentSelectTag\">\r\n              <ng-template\r\n                [ngTemplateOutlet]=\"currentSelectTag.customTemplate || templates[currentSelectTag.type]\"\r\n                [ngTemplateOutletContext]=\"{ tagOption: currentSelectTag, dropdown: inputDropdown }\"\r\n              ></ng-template>\r\n            </ng-container>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </ul>\r\n  </div>\r\n  <div class=\"devui-category-search-extended-container\" *ngIf=\"showExtendedConfig\">\r\n    <ng-template *ngIf=\"operationConfig.clear.show\" [ngTemplateOutlet]=\"operationConfig.clear.template || clearTpl\"></ng-template>\r\n    <ng-template *ngIf=\"operationConfig.save.show\" [ngTemplateOutlet]=\"operationConfig.save.template || saveTpl\"></ng-template>\r\n    <ng-template *ngIf=\"operationConfig.more.show\" [ngTemplateOutlet]=\"operationConfig.more.template || moreTpl\"></ng-template>\r\n    <ng-template *ngIf=\"operationConfig.customTemplate\" [ngTemplateOutlet]=\"operationConfig.customTemplate\"></ng-template>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #defaultGroupNameTemplate let-item=\"tag\">\r\n  <strong>{{ item?.groupName }}</strong>\r\n</ng-template>\r\n\r\n<ng-template #defaultCategoryNameTemplate let-item=\"tag\">\r\n  <span title=\"{{ item?.label }}\">{{ item?.label }}</span>\r\n</ng-template>\r\n\r\n<ng-template #noData>\r\n  <div class=\"devui-no-data-tip\">{{ i18nCommonText?.noData }}</div>\r\n</ng-template>\r\n\r\n<ng-template #clearTpl>\r\n  <div\r\n    class=\"devui-category-search-icon\"\r\n    [class.disabled]=\"operationConfig.clear.disabled\"\r\n    (click)=\"!operationConfig.clear.disabled && clearFilter($event)\"\r\n  >\r\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\">\r\n      <title>{{ i18nCategorySearchText?.clearFilterCondition }}</title>\r\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n        <path\r\n          d=\"M4.61289944,3.20970461 L4.70710678,3.29289322 L8,6.585 L11.2928932,3.29289322 C11.6834175,2.90236893 12.3165825,2.90236893 12.7071068,3.29289322 C13.0675907,3.65337718 13.0953203,4.22060824 12.7902954,4.61289944 L12.7071068,4.70710678 L9.415,8 L12.7071068,11.2928932 C13.0976311,11.6834175 13.0976311,12.3165825 12.7071068,12.7071068 C12.3466228,13.0675907 11.7793918,13.0953203 11.3871006,12.7902954 L11.2928932,12.7071068 L8,9.415 L4.70710678,12.7071068 C4.31658249,13.0976311 3.68341751,13.0976311 3.29289322,12.7071068 C2.93240926,12.3466228 2.90467972,11.7793918 3.20970461,11.3871006 L3.29289322,11.2928932 L6.585,8 L3.29289322,4.70710678 C2.90236893,4.31658249 2.90236893,3.68341751 3.29289322,3.29289322 C3.65337718,2.93240926 4.22060824,2.90467972 4.61289944,3.20970461 Z\"\r\n          fill-rule=\"nonzero\"\r\n        ></path>\r\n      </g>\r\n    </svg>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #saveTpl>\r\n  <div\r\n    class=\"devui-category-search-icon\"\r\n    #saveDropdown=\"d-dropdown\"\r\n    dDropDown\r\n    appendToBody\r\n    [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\r\n    [class.disabled]=\"operationConfig.save.disabled\"\r\n    [closeScope]=\"'blank'\"\r\n    [disabled]=\"operationConfig.save.disabled\"\r\n    (toggleEvent)=\"createFilterInputAutoFocus(saveDropdown, createFilterInput, filterNameForm)\"\r\n  >\r\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" version=\"1.1\" dDropDownToggle>\r\n      <title>{{ textConfig.createFilter }}</title>\r\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n        <path\r\n          d=\"M12,1 L15,4 L15,13 C15,14.1045695 14.1045695,15 13,15 L3,15 C1.8954305,15 1,14.1045695 1,13 L1,3 C1,1.8954305 1.8954305,1 3,1 L12,1 Z M11.171,3 L3,3 L3,13 L4,13 L4,10 C4,9.48716416 4.38604019,9.06449284 4.88337887,9.00672773 L5,9 L11,9 C11.5128358,9 11.9355072,9.38604019 11.9932723,9.88337887 L12,10 L12,13 L13,13 L13,4.829 L11.171,3 Z M9.999,10.999 L5.999,10.999 L6,13 L10,13 L9.999,10.999 Z M7,5 C7.55228475,5 8,5.44771525 8,6 C8,6.55228475 7.55228475,7 7,7 L5,7 C4.44771525,7 4,6.55228475 4,6 C4,5.44771525 4.44771525,5 5,5 L7,5 Z\"\r\n          fill-rule=\"nonzero\"\r\n        ></path>\r\n      </g>\r\n    </svg>\r\n    <div dDropDownMenu class=\"devui-save-panel\">\r\n      <div class=\"devui-save-panel-title\">\r\n        <span>{{ textConfig.createFilter }}</span>\r\n      </div>\r\n      <div class=\"devui-save-filter-name\">\r\n        <span>{{ textConfig.filterTitle }}</span>\r\n        <form #filterNameForm=\"ngForm\">\r\n          <input\r\n            name=\"filter-name\"\r\n            class=\"devui-category-search-toggle\"\r\n            autocomplete=\"off\"\r\n            #createFilterInput\r\n            dTextInput\r\n            [(ngModel)]=\"filterName\"\r\n            [placeholder]=\"i18nCategorySearchText?.placeholder || ''\"\r\n            [dValidateRules]=\"filterNameRules\"\r\n          />\r\n          <svg\r\n            *ngIf=\"showFilterNameClear\"\r\n            (click)=\"$event.preventDefault(); $event.stopPropagation(); filterNameForm.form.reset()\"\r\n            width=\"16px\"\r\n            height=\"16px\"\r\n            viewBox=\"0 0 16 16\"\r\n          >\r\n            <title>{{ i18nCategorySearchText?.clearFilterCondition }}</title>\r\n            <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n              <path\r\n                d=\"M4.61289944,3.20970461 L4.70710678,3.29289322 L8,6.585 L11.2928932,3.29289322 C11.6834175,2.90236893 12.3165825,2.90236893 12.7071068,3.29289322 C13.0675907,3.65337718 13.0953203,4.22060824 12.7902954,4.61289944 L12.7071068,4.70710678 L9.415,8 L12.7071068,11.2928932 C13.0976311,11.6834175 13.0976311,12.3165825 12.7071068,12.7071068 C12.3466228,13.0675907 11.7793918,13.0953203 11.3871006,12.7902954 L11.2928932,12.7071068 L8,9.415 L4.70710678,12.7071068 C4.31658249,13.0976311 3.68341751,13.0976311 3.29289322,12.7071068 C2.93240926,12.3466228 2.90467972,11.7793918 3.20970461,11.3871006 L3.29289322,11.2928932 L6.585,8 L3.29289322,4.70710678 C2.90236893,4.31658249 2.90236893,3.68341751 3.29289322,3.29289322 C3.65337718,2.93240926 4.22060824,2.90467972 4.61289944,3.20970461 Z\"\r\n                fill-rule=\"nonzero\"\r\n              ></path>\r\n            </g>\r\n          </svg>\r\n        </form>\r\n      </div>\r\n      <div class=\"devui-save-panel-operation-area\">\r\n        <d-button [disabled]=\"filterNameForm.invalid\" (btnClick)=\"createFilterFn(); saveDropdown.toggle()\">{{\r\n          i18nCategorySearchText?.confirm\r\n        }}</d-button>\r\n        <d-button bsStyle=\"common\" (btnClick)=\"saveDropdown.toggle()\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #moreTpl>\r\n  <div\r\n    class=\"devui-category-search-icon\"\r\n    #seeMoreDropdown=\"d-dropdown\"\r\n    dDropDown\r\n    appendToBody\r\n    [alignOrigin]=\"primeContainer\"\r\n    [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\r\n    [class.disabled]=\"operationConfig.more.disabled\"\r\n  >\r\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" dDropDownToggle>\r\n      <title>{{ i18nCategorySearchText?.seeMore }}</title>\r\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\r\n        <path\r\n          d=\"M1,2 L3,2 L3,4 L1,4 L1,2 Z M1,7 L3,7 L3,9 L1,9 L1,7 Z M1,12 L3,12 L3,14 L1,14 L1,12 Z M5,2 L15,2 L15,4 L5,4 L5,2 Z M5,7 L15,7 L15,9 L5,9 L5,7 Z M5,12 L15,12 L15,14 L5,14 L5,12 Z\"\r\n          fill-rule=\"nonzero\"\r\n        ></path>\r\n      </g>\r\n    </svg>\r\n    <div dDropDownMenu class=\"devui-selected-tags-list\">\r\n      <ul [ngStyle]=\"{ width: PrimeContainer?.clientWidth + 'px' }\">\r\n        <li class=\"devui-tag-item\" *ngFor=\"let item of selectedTags; let i = index\" (click)=\"scrollToTag(i, $event)\">\r\n          <ng-template\r\n            [ngTemplateOutlet]=\"joinLabelTypesTemplate\"\r\n            [ngTemplateOutletContext]=\"{ item: item, isJoinLabelType: joinLabelTypes.includes(item.type) }\"\r\n          ></ng-template>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #joinLabelTypesTemplate let-item=\"item\" let-isJoinLabelType=\"isJoinLabelType\">\r\n  <div class=\"devui-tag-container\">\r\n    <d-tag\r\n      [tag]=\"item\"\r\n      [deletable]=\"item.deletable === false ? false : true\"\r\n      [titleContent]=\"item.title\"\r\n      [customViewTemplate]=\"item.tagCustomTemplate || (isJoinLabelType ? defaultJoinLabelTypeTemplate : defaultTagTemplate)\"\r\n      (tagDelete)=\"removeTag(item, $event.event)\"\r\n    ></d-tag>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #defaultTagTemplate let-tag=\"tag\">\r\n  <span [style.maxWidth]=\"tagMaxWidth + 'px'\">{{ tag.label + ': ' + (tag.value[tag.filterKey || 'label'] || '') }}</span>\r\n</ng-template>\r\n\r\n<ng-template #defaultJoinLabelTypeTemplate let-tag=\"tag\" let-colorKey=\"tag.colorKey || 'color'\">\r\n  <span>{{ tag.label }}: </span>\r\n  <span class=\"devui-category-search-multi-tag\" [style.max-width]=\"tagMaxWidth + 'px'\">\r\n    <ng-container *ngFor=\"let val of tag.value.cache; let i = index\">\r\n      <span *ngIf=\"i > 0\" class=\"devui-color-block-split-line\">{{ textConfig.labelConnector || '|' }}</span>\r\n      <span *ngIf=\"tag.type === 'label'\" class=\"devui-color-block-sm\" [style.background]=\"val[colorKey]\"></span>\r\n      <span [style.color]=\"val[colorKey]\" [style.max-width]=\"tagMaxWidth + 'px'\">{{ val[tag.filterKey || 'label'] || '' }}</span>\r\n    </ng-container>\r\n  </span>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'radio'\" let-tagOption=\"tagOption\" let-key=\"tagOption.filterKey || 'label'\">\r\n  <div *ngIf=\"!tagOption.options?.length\">\r\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\r\n  </div>\r\n  <ul *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template devui-scrollbar\">\r\n    <li\r\n      *ngFor=\"let item of tagOption.options\"\r\n      title=\"{{ item[key] }}\"\r\n      class=\"devui-dropdown-item\"\r\n      [class.active]=\"tagOption?.value[key] === item[key]\"\r\n      (click)=\"chooseItem(tagOption, item)\"\r\n    >\r\n      <span>{{ item[key] }}</span>\r\n    </li>\r\n  </ul>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'dateRange'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <d-datepicker-calendar\r\n    #datepickerCalendarItem\r\n    *ngIf=\"dropdown.isOpen\"\r\n    id=\"{{ tagOption.field }}\"\r\n    style=\"overflow-x: hidden\"\r\n    #dDatepickerPro\r\n    [isRangeType]=\"true\"\r\n    [showTime]=\"tagOption.showTime\"\r\n    [activeRangeType]=\"tagOption.activeRangeType || 'start'\"\r\n    [(ngModel)]=\"tagOption.value.value\"\r\n    (input)=\"dateChange(datepickerCalendarItem, tagOption)\"\r\n  >\r\n    <ng-template #footerTemplate>\r\n      <div class=\"devui-datepicker-footer\">\r\n        <d-button\r\n          style=\"margin-right: 8px\"\r\n          bsStyle=\"primary\"\r\n          (btnClick)=\"confirmDate(datepickerCalendarItem, tagOption, dropdown)\"\r\n          [disabled]=\"\r\n            tagOption.showTime ? false : !tagOption.value.value || tagOption.value.value.length < 2 || tagOption.value.value.includes(null)\r\n          \"\r\n        >\r\n          {{ i18nCategorySearchText?.confirm }}\r\n        </d-button>\r\n        <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n      </div>\r\n    </ng-template>\r\n  </d-datepicker-calendar>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'checkbox'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <div *ngIf=\"!tagOption.options?.length\">\r\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\r\n  </div>\r\n  <div *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template devui-scrollbar\">\r\n    <d-checkbox-group\r\n      [(ngModel)]=\"tagOption.value.value\"\r\n      [options]=\"tagOption.options\"\r\n      [filterKey]=\"tagOption.filterKey || 'label'\"\r\n      [isShowTitle]=\"true\"\r\n    >\r\n    </d-checkbox-group>\r\n  </div>\r\n  <div class=\"devui-dropdown-operation-area\">\r\n    <d-button (btnClick)=\"chooseItems(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'label'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <div *ngIf=\"!tagOption.options?.length\">\r\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\r\n  </div>\r\n  <div *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template devui-scrollbar\">\r\n    <d-checkbox-group\r\n      [(ngModel)]=\"tagOption.value.value\"\r\n      [options]=\"tagOption.options\"\r\n      [filterKey]=\"'$label'\"\r\n      [labelTemplate]=\"labelContent\"\r\n      [isShowTitle]=\"true\"\r\n    >\r\n      <ng-template #labelContent let-label=\"label\">\r\n        <span class=\"devui-color-block\" [style.background]=\"splitLabel('color', label)\" title=\"{{ splitLabel('label', label) }}\"></span>\r\n        <span title=\"{{ splitLabel('label', label) }}\">{{ splitLabel('label', label) }}</span>\r\n      </ng-template>\r\n    </d-checkbox-group>\r\n  </div>\r\n  <div class=\"devui-dropdown-operation-area\">\r\n    <d-button (btnClick)=\"chooseItems(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'textInput'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <form #textInputForm=\"ngForm\">\r\n    <input\r\n      name=\"text-input\"\r\n      class=\"devui-category-search-type-text-input\"\r\n      autocomplete=\"off\"\r\n      dTextInput\r\n      [(ngModel)]=\"tagOption.value.value\"\r\n      [maxlength]=\"tagOption.maxLength\"\r\n      [placeholder]=\"tagOption.placeholder || ''\"\r\n      [dValidateRules]=\"tagOption.validateRules\"\r\n    />\r\n  </form>\r\n  <div class=\"devui-dropdown-operation-area\">\r\n    <d-button [disabled]=\"textInputForm.invalid\" (btnClick)=\"getTextInputValue(tagOption); closeMenu(dropdown)\">{{\r\n      i18nCategorySearchText?.confirm\r\n    }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'numberRange'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\r\n  <div class=\"devui-input-number-operation-area\">\r\n    <d-input-number\r\n      size=\"sm\"\r\n      [min]=\"tagOption.min?.left\"\r\n      [max]=\"tagOption.max?.left\"\r\n      [maxLength]=\"tagOption.maxLength?.left\"\r\n      [step]=\"tagOption.step?.left || 1\"\r\n      [reg]=\"tagOption.reg?.left\"\r\n      [placeholder]=\"tagOption.placeholder?.left || ''\"\r\n      [(ngModel)]=\"tagOption.value.value[0]\"\r\n    >\r\n    </d-input-number>\r\n    <span> - </span>\r\n    <d-input-number\r\n      size=\"sm\"\r\n      [min]=\"tagOption.min?.right\"\r\n      [max]=\"tagOption.max?.right\"\r\n      [maxLength]=\"tagOption.maxLength?.right\"\r\n      [step]=\"tagOption.step?.right || 1\"\r\n      [reg]=\"tagOption.reg?.right\"\r\n      [placeholder]=\"tagOption.placeholder?.right || ''\"\r\n      [(ngModel)]=\"tagOption.value.value[1]\"\r\n    >\r\n    </d-input-number>\r\n  </div>\r\n  <div class=\"devui-dropdown-operation-area\">\r\n    <d-button (btnClick)=\"getNumberRangeValue(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template [dType]=\"'treeSelect'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\" let-isSelected=\"isSelected\">\r\n  <div *ngIf=\"tagOption.multiple && tagOption.options?.length && tagOption.value.value?.length\">\r\n    <ul class=\"devui-select-list\">\r\n      <span>{{ i18nCategorySearchText?.selected }}</span>\r\n      <li class=\"devui-select-item devui-no-label-item\" *ngFor=\"let item of tagOption.value.value; last as isLast\">\r\n        {{ item[tagOption.filterKey || tagOption.treeNodeTitleKey || 'title'] }}\r\n        <span *ngIf=\"!isLast\">, </span>\r\n      </li>\r\n    </ul>\r\n  </div>\r\n  <div *ngIf=\"tagOption.searchable\" class=\"devui-search-container\">\r\n    <d-search\r\n      [placeholder]=\"tagOption.searchPlaceholder\"\r\n      [ngModel]=\"treeSearchKey\"\r\n      (ngModelChange)=\"treeSearch($event, tagOption.searchFn)\"\r\n    ></d-search>\r\n  </div>\r\n  <div class=\"devui-category-search-tree-container\" [style.display]=\"tagOption.options?.length && !treeNoRecord ? 'block' : 'none'\">\r\n    <d-operable-tree\r\n      #OperableTree\r\n      *ngIf=\"dropdown.isOpen || treeResetFlag\"\r\n      class=\"devui-tree\"\r\n      [tree]=\"isSelected ? tagOption.value.options : tagOption.options\"\r\n      [treeNodeIdKey]=\"tagOption.treeNodeIdKey || 'id'\"\r\n      [treeNodeChildrenKey]=\"tagOption.treeNodeChildrenKey || 'children'\"\r\n      [treeNodeTitleKey]=\"tagOption.filterKey || tagOption.treeNodeTitleKey || 'title'\"\r\n      [checkboxDisabledKey]=\"tagOption.disabledKey || 'disabled'\"\r\n      [checkable]=\"tagOption.multiple\"\r\n      [canActivateNode]=\"!tagOption.multiple\"\r\n      [canActivateParentNode]=\"!tagOption.leafOnly\"\r\n      [iconParentOpen]=\"tagOption.iconParentOpen || icons.iconParentOpen\"\r\n      [iconParentClose]=\"tagOption.iconParentClose || icons.iconParentClose\"\r\n      [iconLeaf]=\"tagOption.iconLeaf || icons.iconLeaf\"\r\n      (nodeChecked)=\"onOperableNodeChecked($event, tagOption)\"\r\n      (nodeSelected)=\"onOperableNodeSelected($event, tagOption); closeMenu(dropdown)\"\r\n    >\r\n    </d-operable-tree>\r\n  </div>\r\n  <div *ngIf=\"!tagOption.options?.length\">\r\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\r\n  </div>\r\n  <div *ngIf=\"treeNoRecord\" class=\"devui-no-data-tip\">{{ i18nCommonText?.noRecordsFound }}</div>\r\n  <div *ngIf=\"tagOption.multiple\" class=\"devui-dropdown-operation-area\">\r\n    <d-button [disabled]=\"!tagOption.value.value?.length\" (btnClick)=\"getTreeValue(tagOption); closeMenu(dropdown)\">{{\r\n      i18nCategorySearchText?.confirm\r\n    }}</d-button>\r\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\r\n  </div>\r\n</ng-template>\r\n", styles: [".devui-font-size-base{font-size:var(--devui-font-size, 12px)}.devui-font-base{font-size:var(--devui-font-size, 12px);font-weight:var(--devui-font-content-weight, normal);line-height:var(--devui-line-height-base, 1.5)}.devui-font-size-modal-title{font-size:var(--devui-font-size-modal-title, 18px)}.devui-font-modal-title{font-size:var(--devui-font-size-modal-title, 18px);font-weight:var(--devui-font-title-weight, bold);line-height:var(--devui-line-height-base, 1.5)}.devui-font-size-page-title{font-size:var(--devui-font-size-page-title, 16px)}.devui-font-page-title{font-size:var(--devui-font-size-page-title, 16px);font-weight:var(--devui-font-title-weight, bold);line-height:var(--devui-line-height-base, 1.5)}.devui-font-size-secondary-title{font-size:var(--devui-font-size-card-title, 14px)}.devui-font-secondary-title{font-size:var(--devui-font-size-card-title, 14px);font-weight:var(--devui-font-title-weight, bold);line-height:var(--devui-line-height-base, 1.5)}:host:not(.devui-glow-style) .devui-category-search-container.container-hover:hover{border:1px solid var(--devui-form-control-line-hover, #9b9fa8)}.devui-category-search-container{position:relative;border-radius:var(--devui-border-radius, 2px);width:100%;height:32px;padding:0 8px;display:flex;align-items:flex-start;background:transparent;transition:border var(--devui-animation-duration-slow, .3s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1));background-color:var(--devui-base-bg, #ffffff);border:1px solid var(--devui-line, #d7d8da)}.devui-category-search-container.container-hover>.devui-category-search-icon svg g path{fill:var(--devui-icon-fill-hover, #252b3a)}.devui-category-search-container>.devui-category-search-icon{margin-top:6px}.devui-category-search-container.devui-gray-style{background-color:var(--devui-gray-form-control-bg, #f5f5f5);border-color:transparent;transition:all var(--devui-animation-duration-slow, .3s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}.devui-category-search-container.devui-gray-style:hover{background-color:var(--devui-gray-form-control-hover-bg, #ebebeb)}.devui-category-search-container.devui-gray-style:focus-within{background-color:var(--devui-base-bg, #ffffff);border-color:var(--devui-brand, #5e7ce0)}.devui-category-search-container.devui-gray-style .devui-category-search-input input.devui-category-search-toggle{background-color:transparent!important}.devui-category-search-container .devui-category-search-toggle{color:var(--devui-text, #252b3a)}.devui-category-search-container .devui-category-search-line-container{width:100%;height:32px;overflow:hidden}.devui-category-search-container .devui-category-search-line-container:hover{overflow-x:auto;overflow-x:overlay}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line{display:flex;flex-flow:row nowrap;justify-content:flex-start;align-items:flex-start;width:100%;height:30px;position:relative;top:-1px}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line>li{display:flex;align-items:center;flex-grow:0;white-space:nowrap;height:100%}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input{display:flex;justify-content:flex-start;flex-grow:1;align-items:center;min-width:160px;padding-right:20px}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input input{min-width:240px;width:100%;height:32px;font-size:var(--devui-font-size-sm, 12px)}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input .devui-category-search-toggle{padding-left:0}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input .devui-category-search-keyword-in-category{overflow:visible}.devui-category-search-container input{border:none;background:transparent}.devui-category-search-container .devui-input-container{display:flex;flex:1}.devui-category-search-container .devui-category-search-extended-container{display:flex;flex-wrap:nowrap;width:fit-content;height:16px;margin:8px 0;border-left:solid 1px var(--devui-line, #d7d8da);padding-left:8px}.devui-category-search-container .devui-category-search-extended-container:empty{border:none;padding-left:0}.devui-tag-item{display:inline-block;margin-right:4px}.devui-tag-item:first-child{margin-left:4px}.devui-tag-item:focus{outline:none}.devui-tag-item .devui-color-block-split-line{color:var(--devui-aide-text, #71757f)}.devui-tag-item .devui-color-block-sm{width:8px;height:8px;border-radius:var(--devui-border-radius, 2px);margin-right:4px;display:inline-block;position:relative;top:-1px;vertical-align:middle}span:focus{outline:none}.devui-category-search-icon{display:flex;padding-right:8px;align-items:center;height:16px;cursor:pointer}.devui-category-search-icon svg g path{outline:none;fill:var(--devui-icon-fill, #71757f);transition:all var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1)) var(--devui-animation-duration-slow, .3s)}.devui-category-search-icon.disabled{cursor:not-allowed}.devui-category-search-icon.disabled svg g path{fill:var(--devui-disabled-text, #babbc0)}.devui-category-search-icon:not(.disabled):hover svg g path{fill:var(--devui-icon-fill-hover, #252b3a)}input,input:focus{outline:none!important}a:focus,a:hover{color:var(--devui-list-item-hover-text, #252b3a)}d-tag{cursor:pointer}.devui-category-search-toggle{height:30px}.devui-date-picker-operation-area{border-top:1px solid var(--devui-dividing-line, #eef0f5);margin:16px 0;padding:16px 16px 0;display:flex;justify-content:flex-end}.devui-date-picker-operation-area d-button:not(:first-child){margin-left:16px}.devui-dropdown-operation-area{border-top:1px solid var(--devui-dividing-line, #eef0f5);padding-top:8px;margin:8px 0;display:flex;justify-content:center}.devui-dropdown-operation-area d-button:first-child{margin-right:8px}.devui-input-number-operation-area{padding:16px 16px 8px;display:flex;justify-content:space-evenly}.devui-save-panel{width:400px;height:auto;margin-top:4px}.devui-save-panel .devui-save-panel-title{display:flex;justify-content:space-between;height:48px;line-height:48px;border-bottom:1px solid var(--devui-dividing-line, #eef0f5);padding:0 20px;font-size:14px;font-weight:700;color:var(--devui-font-size-page-title, 16px)}.devui-save-panel .devui-save-filter-name{padding:16px 20px}.devui-save-panel .devui-save-filter-name>form{position:relative}.devui-save-panel .devui-save-filter-name>form input{padding-right:28px}.devui-save-panel .devui-save-filter-name>form svg{position:absolute;right:8px;top:50%;transform:translateY(-50%);cursor:pointer}.devui-save-panel .devui-save-filter-name>form svg path{fill:var(--devui-icon-fill, #71757f)}.devui-save-panel .devui-save-filter-name>form svg:hover svg g path{fill:var(--devui-icon-fill-hover, #252b3a)}.devui-save-panel .devui-save-filter-name>span{padding-bottom:8px;display:block;line-height:1em}.devui-save-panel .devui-save-filter-name>input{width:100%;height:32px;margin:4px auto;line-height:20px;border:1px solid var(--devui-form-control-line, #d7d8da)}.devui-save-panel .devui-save-panel-operation-area{padding-bottom:12px;display:flex;justify-content:center}.devui-save-panel .devui-save-panel-operation-area d-button:not(:first-child){margin-left:16px}.devui-dropdown-menu-template{max-width:300px;max-height:352px;overflow:auto}.devui-dropdown-menu-template:empty{display:none}.devui-dropdown-menu-template .devui-category-search-group{font-size:var(--devui-font-size, 12px)}.devui-dropdown-menu-template .devui-category-search-group.devui-dropdown-item:hover{background-color:transparent;color:var(--devui-text, #252b3a);cursor:default}.devui-selected-tags-list ul{display:flex;flex-flow:row wrap;align-items:center;justify-content:flex-start;max-height:390px;overflow:auto}.devui-selected-tags-list ul li{display:flex;flex-grow:0;flex-flow:row wrap;margin:2px 4px 2px 0}.devui-selected-tags-list ul li:last-child{margin-right:0}:host ::ng-deep .devui-tag-container{line-height:1}:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item{display:block!important}:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item .devui-category-search-multi-tag>span,:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item>span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:inline-block;vertical-align:middle;margin:0 4px}:host ::ng-deep .devui-checkbox-column-margin{height:32px!important;line-height:32px!important}::ng-deep .cdk-overlay-container d-datepicker[id=devui-category-search-date-picker] .devui-month-view{box-shadow:none!important}::ng-deep .cdk-overlay-container d-datepicker[id=devui-category-search-date-picker] .devui-month-view tfoot{display:none}::ng-deep .cdk-overlay-container .devui-selected-tags-list ul li .remove-button{right:8px}::ng-deep .cdk-overlay-container .devui-tag-container d-tag>.devui-tag-item{display:block!important}::ng-deep .cdk-overlay-container .devui-tag-container d-tag>.devui-tag-item .devui-category-search-multi-tag>span,::ng-deep .cdk-overlay-container .devui-tag-container d-tag>.devui-tag-item>span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:inline-block;vertical-align:middle;margin:0 4px}::ng-deep .devui-dropdown-top .devui-dropdown-menu-fix,::ng-deep .devui-dropdown-bottom .devui-dropdown-menu-fix,::ng-deep .devui-dropdown-open .devui-dropdown-menu-fix{margin-bottom:0}::ng-deep .devui-dropdown-menu-fix{min-width:200px;margin-left:0;overflow-y:auto;white-space:nowrap}::ng-deep .devui-dropdown-menu-fix.max-height{max-height:405px}::ng-deep .devui-dropdown-menu-fix .devui-checkbox-group{padding:8px 12px 0}::ng-deep .devui-dropdown-menu-fix .devui-checkbox-group .devui-color-block{width:12px;height:12px;margin-right:8px;border-radius:var(--devui-border-radius, 2px);top:-1px;position:relative;vertical-align:middle;display:inline-block}::ng-deep .devui-dropdown-menu-fix .devui-category-search-type-text-input{margin:16px 8px 8px;width:calc(100% - 16px)}::ng-deep .devui-dropdown-menu-fix .devui-select-list{display:flex;flex-wrap:wrap;max-width:300px;padding:8px}::ng-deep .devui-dropdown-menu-fix .devui-select-list span{margin-right:8px}::ng-deep .devui-dropdown-menu-fix .devui-search-container d-search{width:100%}::ng-deep .devui-dropdown-menu-fix .devui-search-container d-search .devui-search .devui-input.devui-clear-exit:not(.devui-icon-left){padding-right:28px}::ng-deep .devui-dropdown-menu-fix .devui-category-search-tree-container{overflow-y:auto;max-height:264px;padding:12px}::ng-deep .devui-dropdown-menu-fix .devui-no-data-tip{padding:12px}::ng-deep .devui-dropdown-menu-fix .devui-yearOption,::ng-deep .devui-dropdown-menu-fix .devui-monthOption{white-space:normal}::ng-deep .devui-dropdown-menu-fix d-datepicker-calendar{display:block}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox{margin:0 -8px;padding:0 8px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:hover{background-color:var(--devui-list-item-hover-bg, #f2f2f3)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:hover label{color:var(--devui-list-item-hover-text, #252b3a)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:active{background-color:var(--devui-list-item-active-bg, #e9edfa)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:active label{color:var(--devui-list-item-active-text, #252b3a)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;width:100%}::ng-deep .devui-dropdown-menu-fix d-input-number{width:70px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group ul{max-height:310px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox{transition:background-color var(--devui-animation-duration-fast, .1s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox label{transition:color var(--devui-animation-duration-fast, .1s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}.devui-dropdown-menu-tip{cursor:text;padding:12px 12px 0;pointer-events:none;color:var(--devui-aide-text, #71757f)}.devui-dividing-line{height:1px;width:100%;background-color:var(--devui-dividing-line, #eef0f5);margin-top:4px}.devui-dropdown-menu{margin-top:4px;padding-bottom:0}.devui-dropdown-menu .devui-dropdown-item .icon-search{margin-right:4px}.devui-no-data-text{padding:8px 0;text-align:center}.devui-datepicker-footer{text-align:center}\n"] }]
        }], ctorParameters: () => [{ type: i1.DevConfigService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i2.I18nService }], propDecorators: { category: [{
                type: Input
            }], defaultSearchField: [{
                type: Input
            }], selectedTags: [{
                type: Input
            }], allowClear: [{
                type: Input
            }], allowSave: [{
                type: Input
            }], allowShowMore: [{
                type: Input
            }], extendedConfig: [{
                type: Input
            }], toggleScrollToTail: [{
                type: Input
            }], searchKey: [{
                type: Input
            }], placeholderText: [{
                type: Input
            }], inputReadOnly: [{
                type: Input
            }], showSearchCategory: [{
                type: Input
            }], categoryInGroup: [{
                type: Input
            }], groupOrderConfig: [{
                type: Input
            }], customGroupNameTemplate: [{
                type: Input
            }], customCategoryNameTemplate: [{
                type: Input
            }], tagMaxWidth: [{
                type: Input
            }], textConfig: [{
                type: Input
            }], filterNameRules: [{
                type: Input
            }], beforeTagChange: [{
                type: Input
            }], toggleEvent: [{
                type: Input
            }], styleType: [{
                type: Input
            }], showGlowStyle: [{
                type: Input
            }], hasGlowStyle: [{
                type: HostBinding,
                args: ['class.devui-glow-style']
            }], searchEvent: [{
                type: Output
            }], selectedTagsChange: [{
                type: Output
            }], createFilterEvent: [{
                type: Output
            }], clearAllEvent: [{
                type: Output
            }], searchKeyChange: [{
                type: Output
            }], inputEle: [{
                type: ViewChild,
                args: ['InputEle', { static: true }]
            }], scrollBarContainer: [{
                type: ViewChild,
                args: ['ScrollBarContainer', { static: true }]
            }], primeContainer: [{
                type: ViewChild,
                args: ['PrimeContainer', { static: true }]
            }], treeInstance: [{
                type: ViewChild,
                args: ['OperableTree']
            }], selectedDropdownList: [{
                type: ViewChildren,
                args: ['selectedDropdown']
            }], defaultTemplates: [{
                type: ViewChildren,
                args: [DefaultTemplateDirective]
            }], contentTemplates: [{
                type: ContentChildren,
                args: [ContentTemplateDirective]
            }] } });

class CategorySearchModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: CategorySearchModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.2.3", ngImport: i0, type: CategorySearchModule, declarations: [CategorySearchComponent, ContentTemplateDirective, DefaultTemplateDirective], imports: [CommonModule,
            FormModule,
            FormsModule,
            DropDownModule,
            TextInputModule,
            SearchModule,
            TagsModule,
            ButtonModule,
            CheckBoxModule,
            InputNumberModule,
            LoadingModule,
            TreeModule,
            PopperModule,
            DatepickerProModule], exports: [CategorySearchComponent, ContentTemplateDirective, DefaultTemplateDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: CategorySearchModule, imports: [CommonModule,
            FormModule,
            FormsModule,
            DropDownModule,
            TextInputModule,
            SearchModule,
            TagsModule,
            ButtonModule,
            CheckBoxModule,
            InputNumberModule,
            LoadingModule,
            TreeModule,
            PopperModule,
            DatepickerProModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: CategorySearchModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormModule,
                        FormsModule,
                        DropDownModule,
                        TextInputModule,
                        SearchModule,
                        TagsModule,
                        ButtonModule,
                        CheckBoxModule,
                        InputNumberModule,
                        LoadingModule,
                        TreeModule,
                        PopperModule,
                        DatepickerProModule,
                    ],
                    declarations: [CategorySearchComponent, ContentTemplateDirective, DefaultTemplateDirective],
                    exports: [CategorySearchComponent, ContentTemplateDirective, DefaultTemplateDirective],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { COLORS, CategorySearchComponent, CategorySearchModule, ContentTemplateDirective, DefaultTemplateDirective };
//# sourceMappingURL=ng-devui-category-search.mjs.map
