import { ElementRef, OnChanges, OnDestroy, Renderer2, SimpleChanges } from '@angular/core';
import { GanttScaleUnit } from './gantt.model';
import * as i0 from "@angular/core";
export declare class GanttMarkerDirective implements OnChanges, OnDestroy {
    private renderer;
    ganttBarContainerElement: HTMLElement;
    ganttScaleContainerOffsetLeft: number;
    monthMark: boolean;
    weekend: boolean;
    today: boolean;
    index: number;
    milestone: string;
    unit: GanttScaleUnit;
    date: Date;
    last: boolean;
    showDaySplitLine: boolean;
    hostElement: HTMLElement;
    monthMarkElement: HTMLElement;
    weekendElement: HTMLElement;
    todayElement: HTMLElement;
    milestoneElement: HTMLElement;
    daySplitLineElement: HTMLElement;
    constructor(element: ElementRef, renderer: Renderer2);
    ngOnChanges(changes: SimpleChanges): void;
    initMarkElement(): void;
    drawSplitLine(): void;
    updateSplitLine(): void;
    destorySplitLine(): void;
    removeMonthMark(): void;
    removeWeekendMark(): void;
    removeTodayMark(): void;
    removeMileStoneMark(): void;
    destroyMarkElement(type?: string): void;
    private setElementsStyle;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<GanttMarkerDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<GanttMarkerDirective, "[dGanttMarker]", never, { "ganttBarContainerElement": { "alias": "ganttBarContainerElement"; "required": false; }; "ganttScaleContainerOffsetLeft": { "alias": "ganttScaleContainerOffsetLeft"; "required": false; }; "monthMark": { "alias": "monthMark"; "required": false; }; "weekend": { "alias": "weekend"; "required": false; }; "today": { "alias": "today"; "required": false; }; "index": { "alias": "index"; "required": false; }; "milestone": { "alias": "milestone"; "required": false; }; "unit": { "alias": "unit"; "required": false; }; "date": { "alias": "date"; "required": false; }; "last": { "alias": "last"; "required": false; }; "showDaySplitLine": { "alias": "showDaySplitLine"; "required": false; }; }, {}, never, never, false, never>;
}
