import { AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy, Renderer2, TemplateRef } from '@angular/core';
import * as i0 from "@angular/core";
export type ISpliceType = 'standalone' | 'left' | 'right' | 'both';
export declare class InputGroupComponent implements AfterViewInit, OnDestroy {
    private cdr;
    private el;
    private render;
    isEmbed: boolean;
    disabled: boolean;
    prefixContent: string | TemplateRef<any>;
    suffixContent: string | TemplateRef<any>;
    spliceType: ISpliceType;
    container: ElementRef;
    get embed(): boolean;
    isPrefix: boolean;
    isSuffix: boolean;
    innerContentClass: string;
    private parent;
    private resizeObserver;
    constructor(cdr: ChangeDetectorRef, el: ElementRef, render: Renderer2);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    checkIsInputGroup(dom: HTMLElement): HTMLElement;
    handlerSpliceStatus: () => void;
    spliceLeft(previous: HTMLElement, rect: DOMRect): void;
    spliceRight(next: HTMLElement, rect: DOMRect): void;
    setInnerContentBorderRadius(): void;
    changeInputPadding(pos: ISpliceType, style: string): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<InputGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<InputGroupComponent, "d-input-group", never, { "isEmbed": { "alias": "isEmbed"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "prefixContent": { "alias": "prefixContent"; "required": false; }; "suffixContent": { "alias": "suffixContent"; "required": false; }; "spliceType": { "alias": "spliceType"; "required": false; }; }, {}, never, ["*"], false, never>;
}
