import { ComponentFactoryResolver, ComponentRef, ElementRef, Injector, OnChanges, SimpleChanges, TemplateRef, ViewContainerRef } from '@angular/core';
import { ILoadingViewPosition, LoadingStyle, LoadingType } from './loading.types';
import * as i0 from "@angular/core";
export declare class LoadingDirective implements OnChanges {
    private componentFactoryResolver;
    private elementRef;
    private injector;
    private triggerElementRef;
    private viewContainerRef;
    backdrop: boolean;
    message: string;
    positionType: string;
    showLoading: boolean;
    view: ILoadingViewPosition;
    zIndex: number;
    loading: LoadingType | boolean;
    loadingStyle: LoadingStyle;
    loadingTemplateRef: TemplateRef<any>;
    position: string;
    active: boolean;
    backdropRef: ComponentRef<any>;
    loadingRef: ComponentRef<any>;
    constructor(componentFactoryResolver: ComponentFactoryResolver, elementRef: ElementRef, injector: Injector, triggerElementRef: ElementRef, viewContainerRef: ViewContainerRef);
    ngOnChanges(changes: SimpleChanges): void;
    loadingChangeEvent(loading: LoadingType): void;
    showLoadingChangeEvent(showLoading: boolean): void;
    private startLoading;
    private endLoading;
    private createLoadingBackdrop;
    private insert;
    static ɵfac: i0.ɵɵFactoryDeclaration<LoadingDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LoadingDirective, "[dLoading]", ["dLoading"], { "backdrop": { "alias": "backdrop"; "required": false; }; "message": { "alias": "message"; "required": false; }; "positionType": { "alias": "positionType"; "required": false; }; "showLoading": { "alias": "showLoading"; "required": false; }; "view": { "alias": "view"; "required": false; }; "zIndex": { "alias": "zIndex"; "required": false; }; "loading": { "alias": "loading"; "required": false; }; "loadingStyle": { "alias": "loadingStyle"; "required": false; }; "loadingTemplateRef": { "alias": "loadingTemplateRef"; "required": false; }; }, {}, never, never, false, never>;
}
