import { ChangeDetectorRef, EventEmitter, OnInit, TemplateRef, QueryList, AfterContentInit } from '@angular/core';
import { MenuComponent } from './menu.component';
import { MenuHoverTypes, SubTitleContextType } from './type';
import { ConnectedPosition } from '@angular/cdk/overlay';
import { MenuItemDirective } from './menu-item.directive';
import { SubMenuService } from './submenu.service';
import * as i0 from "@angular/core";
export declare class SubMenuComponent implements OnInit, AfterContentInit {
    menuItemDirectives: QueryList<MenuItemDirective>;
    subMenuClass: boolean;
    noStyle: boolean;
    _open: boolean;
    set open(value: boolean);
    get open(): boolean;
    disabled: boolean;
    title: string | TemplateRef<SubTitleContextType>;
    icon: string;
    openChange: EventEmitter<boolean>;
    get titleContext(): SubTitleContextType;
    protected submenuService: SubMenuService;
    protected parentMenu: MenuComponent;
    protected cdr: ChangeDetectorRef;
    afterInitAnimate: boolean;
    positions: ConnectedPosition[];
    private childActive;
    collapsed: boolean;
    popoverOpen: boolean;
    constructor();
    ngOnInit(): void;
    ngAfterContentInit(): void;
    titleClick(): void;
    titleHover(type: MenuHoverTypes): void;
    toggleOpen(open: boolean): void;
    togglePopOpen(open: boolean): void;
    get expandState(): "expanded" | "collapsed";
    stateCls(base: string): string;
    toggleActive(active: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SubMenuComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SubMenuComponent, "d-sub-menu, [dSubMenu]", never, { "noStyle": { "alias": "noStyle"; "required": false; }; "open": { "alias": "open"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "title": { "alias": "title"; "required": false; }; "icon": { "alias": "icon"; "required": false; }; }, { "openChange": "openChange"; }, ["menuItemDirectives"], ["[title]", "*"], false, never>;
}
