import { OnInit, TemplateRef } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { IButtonStyle } from 'ng-devui/button';
import { ModalComponent } from './modal.component';
import { ModalContentDirective } from './modal.directive';
import * as i0 from "@angular/core";
export declare class ModalContainerComponent implements OnInit {
    private sanitizer;
    modalInstance: ModalComponent;
    maxHeight: string;
    data: any;
    title: string;
    content: string | HTMLElement;
    showMaximizeBtn: boolean;
    buttons: Array<{
        id?: string;
        cssClass?: IButtonStyle;
        text: string;
        handler: ($event: Event) => void;
        btnwidth?: string;
        autofocus?: boolean;
        disabled: boolean;
    }>;
    html: boolean;
    onClose: ($event?: Event) => void;
    onMaximize: (maximized: boolean) => void;
    modalContentHost: ModalContentDirective;
    dialogtype: string;
    showCloseBtn: boolean;
    contentTemplate: TemplateRef<any>;
    _oldMaxHeight: string;
    constructor(sanitizer: DomSanitizer, modalInstance: ModalComponent);
    ngOnInit(): void;
    close(event: any): void;
    maximize(maximized: boolean): void;
    updateButtonOptions(buttonOptions?: any[]): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ModalContainerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ModalContainerComponent, "d-modal-container", never, { "maxHeight": { "alias": "maxHeight"; "required": false; }; "data": { "alias": "data"; "required": false; }; "title": { "alias": "title"; "required": false; }; "content": { "alias": "content"; "required": false; }; "showMaximizeBtn": { "alias": "showMaximizeBtn"; "required": false; }; "buttons": { "alias": "buttons"; "required": false; }; "html": { "alias": "html"; "required": false; }; "onClose": { "alias": "onClose"; "required": false; }; "onMaximize": { "alias": "onMaximize"; "required": false; }; "dialogtype": { "alias": "dialogtype"; "required": false; }; "showCloseBtn": { "alias": "showCloseBtn"; "required": false; }; }, {}, never, never, false, never>;
}
