import { ElementRef, OnDestroy, OnInit, Renderer2, TemplateRef } from '@angular/core';
import { Observable, Subscription } from 'rxjs';
import { ModalContainerDirective } from './modal.directive';
import * as i0 from "@angular/core";
export declare class ModalComponent implements OnInit, OnDestroy {
    private elementRef;
    private renderer;
    private doc;
    id: string;
    showAnimation: boolean;
    width: string;
    zIndex: number;
    backDropZIndex: number;
    backdropCloseable: boolean;
    beforeHidden: () => boolean | Promise<boolean> | Observable<boolean>;
    draggable: boolean;
    placement: 'center' | 'top' | 'bottom' | 'unset';
    offsetX: string;
    offsetY: string;
    bodyScrollable: boolean;
    escapable: boolean;
    cssClass: string;
    modalContainerHost: ModalContainerDirective;
    dialogElement: ElementRef;
    animateState: string;
    draggableHandleEl: HTMLElement;
    scrollTop: number;
    scrollLeft: number;
    documentOverFlow: boolean;
    mouseDwonEl: ElementRef;
    ignoreBackDropClick: boolean;
    pressEscToClose: Subscription;
    contentTemplate: TemplateRef<any>;
    document: Document;
    maximized: boolean;
    _oldWidth: string;
    constructor(elementRef: ElementRef, renderer: Renderer2, doc: any);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onHidden(): void;
    updateButtonOptions<T>(buttonOptions: Array<T>): void;
    canHideModel(): Promise<boolean>;
    onModalClick: ($event: any) => void;
    modalMouseDown: ($event: any) => void;
    modalMouseUp: ($event: any) => void;
    maximize(): void;
    onAnimationEnd($event: any): void;
    show(): void;
    hide(): void;
    bodyScrollBlock(toggle: boolean): void;
    resolveTransformTranslate(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<ModalComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ModalComponent, "d-modal", never, { "id": { "alias": "id"; "required": false; }; "showAnimation": { "alias": "showAnimation"; "required": false; }; "width": { "alias": "width"; "required": false; }; "zIndex": { "alias": "zIndex"; "required": false; }; "backDropZIndex": { "alias": "backDropZIndex"; "required": false; }; "backdropCloseable": { "alias": "backdropCloseable"; "required": false; }; "beforeHidden": { "alias": "beforeHidden"; "required": false; }; "draggable": { "alias": "draggable"; "required": false; }; "placement": { "alias": "placement"; "required": false; }; "offsetX": { "alias": "offsetX"; "required": false; }; "offsetY": { "alias": "offsetY"; "required": false; }; "bodyScrollable": { "alias": "bodyScrollable"; "required": false; }; "escapable": { "alias": "escapable"; "required": false; }; "cssClass": { "alias": "cssClass"; "required": false; }; }, {}, never, never, false, never>;
}
