import { AfterViewInit, ChangeDetectorRef, ElementRef, OnChanges, OnDestroy, OnInit, Renderer2, SimpleChanges, TemplateRef } from '@angular/core';
import { PositionService } from 'ng-devui/position';
import { Subscription } from 'rxjs';
import { PopoverType, PositionType } from './popover.types';
import * as i0 from "@angular/core";
interface PopoverStyle {
    backgroundColor?: string;
}
export declare class PopoverComponent implements OnInit, AfterViewInit, OnDestroy, OnChanges {
    private renderer;
    private positionService;
    elementRef: ElementRef;
    private cdr;
    private doc;
    triggerElementRef: ElementRef;
    currentPosition: PositionType;
    connectionBias: string;
    _position: PositionType | PositionType[];
    get position(): PositionType | PositionType[];
    set position(pos: PositionType | PositionType[]);
    content: string | HTMLElement | TemplateRef<any>;
    showAnimation: boolean;
    scrollElement: Element;
    appendToBody: boolean;
    zIndex: number;
    popType: PopoverType;
    popMaxWidth: number;
    popoverStyle: PopoverStyle;
    /**
     * @deprecated Use mouseLeaveDelay to replace.
     */
    set hoverDelayTime(delayTime: any);
    mouseEnterDelay: number;
    mouseLeaveDelay: number;
    animateState: string;
    get display(): "block" | "none";
    get class(): string;
    get state(): string;
    get disabled(): boolean;
    get template(): TemplateRef<any>;
    document: Document;
    hasSetScrollElement: boolean;
    subs: Subscription;
    SCROLL_REFRESH_INTERVAL: number;
    constructor(renderer: Renderer2, positionService: PositionService, elementRef: ElementRef, cdr: ChangeDetectorRef, doc: any);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    show(): void;
    hide(): void;
    onHidden(): void;
    onAnimationEnd(event: any): void;
    ngOnDestroy(): void;
    updatePosition(): void;
    checkBounds(rect: any): boolean;
    updatePositionAndDetectChange(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PopoverComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PopoverComponent, "d-popover", never, { "triggerElementRef": { "alias": "triggerElementRef"; "required": false; }; "position": { "alias": "position"; "required": false; }; "content": { "alias": "content"; "required": false; }; "showAnimation": { "alias": "showAnimation"; "required": false; }; "scrollElement": { "alias": "scrollElement"; "required": false; }; "appendToBody": { "alias": "appendToBody"; "required": false; }; "zIndex": { "alias": "zIndex"; "required": false; }; "popType": { "alias": "popType"; "required": false; }; "popMaxWidth": { "alias": "popMaxWidth"; "required": false; }; "popoverStyle": { "alias": "popoverStyle"; "required": false; }; "hoverDelayTime": { "alias": "hoverDelayTime"; "required": false; }; "mouseEnterDelay": { "alias": "mouseEnterDelay"; "required": false; }; "mouseLeaveDelay": { "alias": "mouseLeaveDelay"; "required": false; }; }, {}, never, never, false, never>;
}
export {};
