import { AfterViewInit, OnChanges, QueryList, SimpleChanges, TemplateRef } from '@angular/core';
import { ProgressTemplateDirective } from './progress-template.directive';
import { IGradientColor, IProgressItem, ShowContentConfig } from './progress.types';
import * as i0 from "@angular/core";
export declare class ProgressComponent implements OnChanges, AfterViewInit {
    static ID_SEED: number;
    isDynamic: boolean;
    percentage: number;
    percentageText: string;
    /**
     * @deprecated
     * 用strokeColor替换
     */
    barbgcolor: string;
    strokeColor: string | IGradientColor[];
    /**
     * @deprecated
     * 统一用strokeWidth
     */
    set height(value: any);
    strokeWidth: number;
    /**
     * @deprecated
     * 用type类型替换
     */
    set isCircle(value: boolean);
    type: 'line' | 'circle';
    showContent: boolean | ShowContentConfig;
    multiProgressConfig: IProgressItem[];
    templates: QueryList<ProgressTemplateDirective>;
    id: number;
    pathString: string;
    trailPath: {
        [key: string]: string;
    };
    progressData: IProgressItem[];
    gradientColor: IGradientColor[];
    isGradient: boolean;
    showContentConfig: {
        showInnerContent: boolean;
        showOuterContent: boolean;
        showCenterContent: boolean;
    };
    centerTemplate: TemplateRef<any>;
    outerTemplate: TemplateRef<any>;
    get content(): string;
    constructor();
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    render(): void;
    setCircleProgress(data: IProgressItem[]): void;
    checkSumOfPercentages(data: IProgressItem[], func: Function): void;
    checkStrokeColor(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<ProgressComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ProgressComponent, "d-progress", never, { "isDynamic": { "alias": "isDynamic"; "required": false; }; "percentage": { "alias": "percentage"; "required": false; }; "percentageText": { "alias": "percentageText"; "required": false; }; "barbgcolor": { "alias": "barbgcolor"; "required": false; }; "strokeColor": { "alias": "strokeColor"; "required": false; }; "height": { "alias": "height"; "required": false; }; "strokeWidth": { "alias": "strokeWidth"; "required": false; }; "isCircle": { "alias": "isCircle"; "required": false; }; "type": { "alias": "type"; "required": false; }; "showContent": { "alias": "showContent"; "required": false; }; "multiProgressConfig": { "alias": "multiProgressConfig"; "required": false; }; }, {}, ["templates"], never, false, never>;
}
