import { EventEmitter, TemplateRef } from '@angular/core';
import { ToggleMenuListItem } from './toggle-menu.type';
import * as i0 from "@angular/core";
export declare class ToggleMenuListItemComponent {
    item: ToggleMenuListItem;
    index: number;
    selectIndex: number;
    activeIndex: number;
    /**
     * 【可选】决定下拉框每项文字如何显示，默认显示filterKey字段或者本身的值
     */
    formatter: (item: any) => string;
    /**
     * 【当传入资源（options）类型为Array<{key: value}，必选】针对传入资源options的每项对应字段做过滤操作
     */
    filterKey: string;
    /**
     * 【当传入资源（options）类型为Array<{key: value}，必选】针对传入资源options的每项对应字段做禁用操作的key
     */
    optionDisabledKey: string;
    /**
     * 【当传入资源（options）类型为Array<{key: value}，可选】如使用分组需设置
     */
    optionGroupKey: string;
    /**
     * 【可选】是否允许高亮选项
     */
    highlightToggle: boolean;
    /**
     * 【可选】下拉高亮css
     */
    highlightItemClass: string;
    /**
     * 【可选】是否支持多选
     */
    multiple: boolean;
    /**
     * 【可选】是否需要关键字高亮显示
     */
    isShowKeyword: boolean;
    /**
     * 【可选】auto-complete 中需要高亮显示的关键字
     */
    keyword: string;
    customTemplate: TemplateRef<any>;
    color: string;
    chooseItem: EventEmitter<any>;
    constructor();
    choose(option: any, index: any, event?: Event): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ToggleMenuListItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ToggleMenuListItemComponent, "d-toggle-menu-list-item", never, { "item": { "alias": "item"; "required": false; }; "index": { "alias": "index"; "required": false; }; "selectIndex": { "alias": "selectIndex"; "required": false; }; "activeIndex": { "alias": "activeIndex"; "required": false; }; "formatter": { "alias": "formatter"; "required": false; }; "filterKey": { "alias": "filterKey"; "required": false; }; "optionDisabledKey": { "alias": "optionDisabledKey"; "required": false; }; "optionGroupKey": { "alias": "optionGroupKey"; "required": false; }; "highlightToggle": { "alias": "highlightToggle"; "required": false; }; "highlightItemClass": { "alias": "highlightItemClass"; "required": false; }; "multiple": { "alias": "multiple"; "required": false; }; "isShowKeyword": { "alias": "isShowKeyword"; "required": false; }; "keyword": { "alias": "keyword"; "required": false; }; "customTemplate": { "alias": "customTemplate"; "required": false; }; "color": { "alias": "color"; "required": false; }; }, { "chooseItem": "chooseItem"; }, never, ["[itemPrefix]", "[itemSuffix]"], false, never>;
}
