import { EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { I18nInterface, I18nService } from 'ng-devui/i18n';
import { ToastService } from 'ng-devui/toast';
import { DevConfigService } from 'ng-devui/utils';
import { Observable, Subscription } from 'rxjs';
import { IFileOptions, IUploadOptions, UploadStatus } from './file-uploader.types';
import { SelectFiles } from './select-files.utils';
import { SingleUploadViewComponent } from './single-upload-view.component';
import { SliceUploadService } from './slice-upload.service';
import * as i0 from "@angular/core";
export declare class SingleUploadComponent implements OnDestroy, OnInit, ControlValueAccessor {
    private i18n;
    private selectFiles;
    private doc;
    private toastService;
    private sliceUploadService;
    private devConfigService;
    dSingleUploadView: any;
    uploadOptions: IUploadOptions;
    fileOptions: IFileOptions;
    autoUpload: boolean;
    withoutBtn: boolean;
    showTip: boolean;
    uploadedFiles: Array<Object>;
    uploadedFilesRef: TemplateRef<any>;
    preloadFilesRef?: TemplateRef<any>;
    filePath: string;
    placeholderText: string;
    uploadText: string;
    /**
     * @deprecated
     */
    confirmText: string;
    beforeUpload: (file: any) => boolean | Promise<boolean> | Observable<boolean>;
    dynamicUploadOptionsFn: (files: any, uploadOptions: any) => IUploadOptions;
    enableDrop: boolean;
    disabled: boolean;
    successEvent: EventEmitter<Array<{
        file: File;
        response: any;
    }>>;
    errorEvent: EventEmitter<{
        file: File;
        response: any;
    }>;
    errorChunkEvent: EventEmitter<{
        file: File;
        response: any;
    }>;
    deleteUploadedFileEvent: EventEmitter<string>;
    fileDrop: EventEmitter<any>;
    fileOver: EventEmitter<boolean>;
    fileSelect: EventEmitter<File>;
    showGlowStyle: boolean;
    get hasGlowStyle(): boolean;
    singleUploadViewComponent: SingleUploadViewComponent;
    UploadStatus: typeof UploadStatus;
    isDropOVer: boolean;
    i18nText: I18nInterface['upload'];
    i18nCommonText: I18nInterface['common'];
    i18nSubscription: Subscription;
    errorMsg: any[];
    document: Document;
    private onChange;
    private onTouched;
    constructor(i18n: I18nService, selectFiles: SelectFiles, doc: any, toastService: ToastService, sliceUploadService: SliceUploadService, devConfigService: DevConfigService);
    writeValue(files: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    simulateSelectFiles(files: any): Promise<unknown>;
    ngOnInit(): void;
    _dealFiles(observale: any): void;
    checkValid(): void;
    onClick($event: any): void;
    get filename(): string;
    onFileDrop(files: any): void;
    onFileOver(event: any): void;
    onFileSelect(file: any): void;
    upload(): void;
    canUpload(): Promise<boolean>;
    _onDeleteUploadedFile(filePath: string): void;
    deleteFile($event: any): void;
    alertMsg(errorMsg: any): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SingleUploadComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SingleUploadComponent, "d-single-upload", ["dSingleUpload"], { "uploadOptions": { "alias": "uploadOptions"; "required": false; }; "fileOptions": { "alias": "fileOptions"; "required": false; }; "autoUpload": { "alias": "autoUpload"; "required": false; }; "withoutBtn": { "alias": "withoutBtn"; "required": false; }; "showTip": { "alias": "showTip"; "required": false; }; "uploadedFiles": { "alias": "uploadedFiles"; "required": false; }; "uploadedFilesRef": { "alias": "uploadedFilesRef"; "required": false; }; "preloadFilesRef": { "alias": "preloadFilesRef"; "required": false; }; "filePath": { "alias": "filePath"; "required": false; }; "placeholderText": { "alias": "placeholderText"; "required": false; }; "uploadText": { "alias": "uploadText"; "required": false; }; "confirmText": { "alias": "confirmText"; "required": false; }; "beforeUpload": { "alias": "beforeUpload"; "required": false; }; "dynamicUploadOptionsFn": { "alias": "dynamicUploadOptionsFn"; "required": false; }; "enableDrop": { "alias": "enableDrop"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "showGlowStyle": { "alias": "showGlowStyle"; "required": false; }; }, { "successEvent": "successEvent"; "errorEvent": "errorEvent"; "errorChunkEvent": "errorChunkEvent"; "deleteUploadedFileEvent": "deleteUploadedFileEvent"; "fileDrop": "fileDrop"; "fileOver": "fileOver"; "fileSelect": "fileSelect"; }, never, never, false, never>;
}
